
(function () {
    'use strict';

    angular.module('about.module', [])

    .controller('AboutController',
      ['$scope', '$rootScope','$log','$translate', '$cordovaInAppBrowser',
        function($scope, $rootScope, $log, $translate, $cordovaInAppBrowser) {

            $scope.loadStrings= function(){
                var keys = []
                keys.push("about_title");
                keys.push("about_content_title");
                keys.push("about_content_text");
                keys.push("about_create_event");

                $translate(keys).then(function (translations) {
                  $scope.data.strings["about_title"] = translations["about_title"];
                  $scope.data.strings["about_content_title"] = translations["about_content_title"];
                  $scope.data.strings["about_content_text"] = translations["about_content_text"];
                  $scope.data.strings["about_create_event"] = translations["about_create_event"];
                });
            };

            $scope.$on("$ionicView.loaded", function(event, data){
              $scope.data = {strings:[]};
              $scope.loadStrings()
            });

            $scope.$on('$translateChangeSuccess', function () {
              $scope.loadStrings();
            });

            $scope.createNewEvent = function(){
              $cordovaInAppBrowser.open("https://www.metooo.io", '_system', {})
              .then(function(event) {
                // success
              })
              .catch(function(event) {
                // error
              });
            }


        }
      ]
    )

})();

;
