angular.module('application', [
    'ionic',
    'ngCordova',
    'app.directives',
    'app.routes',
    'app.translations',
    'app.settings',
    'intro.module',
    'profile.module',
    'about.module',
    'privacy.module',
    'main.module',
    'myevents.module',
    'events.module',
    'auth.module',
    'base64',
    // 'flyers.module',
    'pascalprecht.translate','ngCordovaOauth',
    'tmh.dynamicLocale',
    'uiGmapgoogle-maps'
])


// Enable native scrolls for Android platform only,
// as you see, we're disabling jsScrolling to achieve this.
    .config(function ($ionicConfigProvider, $translateProvider,tmhDynamicLocaleProvider,uiGmapGoogleMapApiProvider, $sceDelegateProvider) {
      $ionicConfigProvider.views.swipeBackEnabled(false);

      $sceDelegateProvider.resourceUrlWhitelist([
          // Allow same origin resource loads.
          'self',
          // Allow loading from outer templates domain.
          'http://www.sandbox.paypal.com/**',
          'https://www.sandbox.paypal.com/**',
          'https://www.paypal.com/**',
          'http://www.paypal.com/**',
          'https://api.metooo.io/**',
        ]);
      uiGmapGoogleMapApiProvider.configure({
             key: 'AIzaSyDtldt1fE4eLvuprTTXGxfxRAAhYLMF4CE',
             v: '3.24', //defaults to latest 3.X anyhow
             libraries: 'visualization,places',
             language:'it'
         });

        $ionicConfigProvider.navBar.alignTitle('left')
        $ionicConfigProvider.views.transition('android');

        if (ionic.Platform.isAndroid()) {
            $ionicConfigProvider.scrolling.jsScrolling(false);
        }
        tmhDynamicLocaleProvider.localeLocationPattern('lib/angular-i18n/angular-locale_{{locale}}.js');

        // $ionicConfigProvider.navBar.alignTitle('left')
        // $ionicConfigProvider.views.transition('ios');


    })

    .run(function ($ionicPlatform, $rootScope, $ionicHistory, AuthServices,   $timeout, $state, $cordovaInAppBrowser,
        $location, $cordovaStatusbar, $translate, $ionicModal, EventsServices, tmhDynamicLocale, $locale, $http, $log) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            // if (window.cordova && window.cordova.plugins.Keyboard) {
            //     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            // }
            // cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);

            EventsServices.getCurrentPosition();

            if (window.StatusBar) {
                $cordovaStatusbar.overlaysWebView(false);
                $cordovaStatusbar.style(2);
                $cordovaStatusbar.styleHex('#045574');
            }


            // tmhDynamicLocale.set("it");
          //  alert($locale.id);
            if (typeof navigator.globalization !== "undefined") {
                navigator.globalization.getPreferredLanguage(function (language) {
                    $translate.use((language.value).split("-")[0]).then(function (data) {
                      tmhDynamicLocale.set((language.value).split("-")[0]);
                    }, function (error) {
                        $translate.use("it");
                        tmhDynamicLocale.set("it");
                    });
                }, null);
            }
        });

        $rootScope.clearContent = function(text){

          var retval = text ? String(text).replace("<a", '<span') : '';
          retval = retval ? String(retval).replace("</a>", '</span>') : '';
          retval = retval ? String(retval).replace("href=", 'hhref=') : '';
        //  var retval = text ? String(text).replace(/<a href="#"[^>]+<\/a>/gm, '') : '';
          // // var retval = text ? String(text).replace(/<a href=\"#\" [^>]+>/gm, '<span style="display:none">') : '';
          //  var retval =   retval ? String(retval).replace(/<a[^>]+>/gm, '') : '';
          return retval;
        }

        $rootScope.openURL = function(event, url){
          event.preventDefault();
            var options = {
              location: 'yes',

              toolbar: 'yes'
            };

            $cordovaInAppBrowser.open(url , '_system', options)
            .then(function(event) {
              // success
              // $log.log("SUCCESS: " + JSON.stringify(event));
            })
            .catch(function(event) {
              // error
                // $log.log("ERROR: " + JSON.stringify(event));
            });

        }

        $rootScope.privacyText = '';
        $rootScope.loadPrivacyText = function(){
          var l = $translate.use() ||   $translate.preferredLanguage()  || 'it';//||   $translate.storage().get($translate.storageKey());

          $http.get("https://api.metooo.io/cms/permalink?permalink=privacy", { headers:  { Locale:  l } })
          .then(
            function (result) {
              //  alert(vm.result);
              // var css='';
              try {
                $rootScope.privacyText = $rootScope.clearContent(result.data.fields[l].content);

              } catch (e) {
                 //alert(e+':'+angular.toJson(result));
              }
              // $ionicLoading.hide();
            },
            function(err){
              // $ionicLoading.hide();
              // $cordovaDialogs.alert("Problemi su lettura info privacy");
              $log.error("Problemi su lettura info privacy:"+err);
            }
          );
        }
        $rootScope.loadPrivacyText();

        $rootScope.logout = function () {
            AuthServices.logout();
            delete $rootScope.user;
            $location.path("/authenticate.login");

        }

        $rootScope.AuthModal = null;
        $rootScope.authdest = "main.events";
        $rootScope.authOnly = false;
        $rootScope.showAuthModal = function () {
          $rootScope.doShowAuthModal('login');
        }

        $rootScope.doShowAuthModal = function (mode) {
          $rootScope.authMode = mode;

          if($rootScope.AuthModal!=null){
            $rootScope.AuthModal.show();
            return;
          }
          $ionicModal.fromTemplateUrl('app/auth/html/auth-modal.html', {
              id:'auth',
              mode:mode,
              scope: $rootScope,
              animation: 'slide-in-up',
              backdropClickToClose:false
          }).then(function (modal) {
              $rootScope.AuthModal = modal;
              $rootScope.AuthModal.show();
          });
        }

        $rootScope.doShowAuthModalExt = function (mode, scope, callback) {
          $rootScope.authMode = mode;

          if($rootScope.AuthModal!=null){
            $rootScope.AuthModal.show();
            return;
          }
          $ionicModal.fromTemplateUrl('app/auth/html/auth-modal.html', {
              id:'auth',
              callback:callback,
              mode:mode,
              scope: scope,
              animation: 'slide-in-up',
              backdropClickToClose:false
          }).then(function (modal) {
              $rootScope.AuthModal = modal;
              $rootScope.AuthModal.show();
          });
        }
        $rootScope.hideAuthModal = function(){
            if($rootScope.AuthModal!=null){
                $rootScope.AuthModal.hide();
                $rootScope.AuthModal.remove();
                $rootScope.AuthModal = null;
            }
        }

        $rootScope.loginApp = function () {
          $timeout(function () {
            $rootScope.doShowAuthModal('login');
          }, 100);

            //localStorage.setItem('showIntro', 1);
            // $location.path("/authenticate/login");
        }

        $rootScope.signupApp = function () {
          $timeout(function () {
            $rootScope.doShowAuthModal('signup');
          }, 100);

          //  localStorage.setItem('showIntro', 1);
            // $location.path("/authenticate/signup");

        }

        $rootScope.showPrivacy = function () {
          if($rootScope.privacyModal!=null){
            $rootScope.privacyModal.show();
            return;
          }
          $ionicModal.fromTemplateUrl('app/privacy/html/privacy-modal.html', {
              id:'privacy',
              scope: $rootScope,
              animation: 'slide-in-up',
              backdropClickToClose:false
          }).then(function (modal) {
              $rootScope.privacyModal = modal;
              $rootScope.privacyModal.show();
          });
        }


        $rootScope.closePrivacy = function(){
          if($rootScope.privacyModal!=null){
            $rootScope.privacyModal.hide();
            $rootScope.privacyModal.remove();
            $rootScope.privacyModal = null;
          }
        }

        $rootScope.startApp = function () {
            $location.path("/main/events");
        }

        $rootScope.$on('$stateChangeStart', function (event, toState,
            toStateParams, fromState, fromStateParams) {
            $rootScope.title = toStateParams.title;
            $rootScope.user = AuthServices.getLoggedUser();
        });

        $rootScope.$on('$stateChangeSuccess',function(event, toState, toParams, fromState, fromParams){
          $rootScope.statename = $state.current.name;
        });

    })

    ;
