(function () {
    'use strict';

    angular
        .module('auth.module')
        .controller('AuthController', AuthController)
        .controller('SignupController', SignupController)
        .controller('PwdRecController', PwdRecController)
        .controller('AuthModalController', AuthModalController);


    AuthModalController.$inject = [ '$scope', '$rootScope', '$log','$translate','$ionicTabsDelegate', '$ionicModal'];
    function AuthModalController($scope, $rootScope, $log, $translate, $ionicTabsDelegate, $ionicModal) {
      //$log.log('AuthModalController');

      var vm = angular.extend(this, {
        view_title:'',
        authMode:'login',
        setAuthMode: setAuthMode,
        refreshView: refreshView,
      });

      // Execute action on hide modal
      $scope.$on('modal.hidden', function(event,modal) {
        // alert("hide");
        if(modal.id=="auth" && modal.callback){
          modal.callback();
        }
      });
      function setAuthMode(m){
        //$log.info('setAuthMode '+m)
        $rootScope.authMode = m;
        vm.authMode = m;
        vm.refreshView();
      }

      $rootScope.gotoPwdrec=function(){
        //console.log('pwdrec');
        $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(2);
      }


      function refreshView(){
        //$log.info('refreshView ');
        $translate(vm.authMode+'_title').then(function (translation) {
          //$log.info('refreshView translate:'+  vm.authMode+'_title'+" = "+translation);
            vm.view_title = translation;
        });
      }
      $scope.$on('modal.shown', function(event, modal) {
          if(modal.id=='auth'){
            if(modal.mode=='login'){
              $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(0);
            }else{
             $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(1);
            }
            vm.refreshView();
          }
      });


    $scope.$on('$ionicView.loaded', function(event, modal) {
          if(vm.authMode=='login'){
            $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(0);
          }else{
           $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(1);
          }

        //  vm.refreshView();
    });

    $scope.init = function(){


      if(vm.authMode=='login'){
        $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(0);
      }else{
       $ionicTabsDelegate.$getByHandle('mt-auth-tabs').select(1);
      }
      vm.refreshView();

    };

    $scope.init();

  }




    AuthController.$inject = ['$scope','$state', '$rootScope', 'AuthServices',
        '$ionicLoading', '$cordovaOauth', '$http', '$ionicModal','$cordovaDialogs', '$filter', '$interpolate',
    ];


    function AuthController($scope, $state, $rootScope, AuthServices,  $ionicLoading, $cordovaOauth, $http, $ionicModal,$cordovaDialogs,  $filter, $interpolate) {

        var vm = angular.extend(this, {
            login: login,
            fbLogin: fbLogin,
            linkedinAuth: linkedinAuth,
            googleAuth: googleAuth,
            loggedUser: getLoggedUser,
            pass: "",
            email: "",
            password: "",
            view: 0,
            showPassword:false,
            switchView: switchView,
            gotoPwdrec:gotoPwdrec,
            validateLogin: validateLogin
        });

        function gotoPwdrec(){
          //console.log('gotoPwdrec');
          $rootScope.gotoPwdrec();
        }

        function switchView(viewNumber) {
            vm.view = viewNumber;
        }

        function googleAuth() {
            var token = "";
            $cordovaOauth.google("1016247754698.apps.googleusercontent.com", ["https://www.googleapis.com/auth/userinfo.profile", "https://www.googleapis.com/auth/userinfo.email"])
                .then(function (result) {
                    token = result.access_token;

                    $http.get("https://www.googleapis.com/oauth2/v3/userinfo", { params: { access_token: result.access_token } })
                        .then(function (result) {
                            $ionicLoading.show({
                                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                                template: '{{"loading_login" | translate}}'
                            });
                            AuthServices.login(result.data.email, result.data.sub, 3, token).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                        $rootScope.$broadcast('mt-user-logged');
                                        $rootScope.hideAuthModal();
                                          if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                                           if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else{

                                      var string = 'My Name is {{name}}';

                                      $cordovaDialogs.alert( response.msg,  $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );
                                    }
                                },
                                function (err) {

                                    $cordovaDialogs.alert( err,  $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' )
                                }
                              );
                        }, function (error) {
                            $cordovaDialogs.alert( error,  $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );
                        });
                }, function (error) {
                    $cordovaDialogs.alert( error,  $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' )
                });
        }


        function linkedinAuth() {
            var token = "";
            $cordovaOauth.linkedin("gcevb22qvhxu", "kl18UhAIOQJqyXGx", ['r_emailaddress'], "dGCM6crUNkv6x6QW158a12R1QSydA15K")
                .then(function (result) {
                    token = result.access_token;
                    $http.get("https://api.linkedin.com/v1/people/~:(email-address,id)?oauth2_access_token=" + token + "&format=json")
                        .then(function (result) {
                            $ionicLoading.show({
                                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                                template: '{{"loading_login" | translate}}'
                            });
                            AuthServices.login(result.data.emailAddress, result.data.id, 4, token.trim()).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                          $rootScope.$broadcast('mt-user-logged');
                                          $rootScope.hideAuthModal();
                                          if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                                          if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else
                                        $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' )

                                });
                        }, function (error) {
                          //  alert("There was a problem getting your profile.  Check the logs for details.");
                            //console.log(error);
                        });
                }, function (error) {
                    $cordovaDialogs.alert( error,  $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );
                });
        }

        function fbLogin() {
            var token = "";
            $cordovaOauth.facebook("233646893428965", ["email"])
                .then(function (result) {
                    token = result.access_token;
                    $http.get("https://graph.facebook.com/v2.2/me", { params: { access_token: result.access_token, fields: "email", format: "json" } })
                        .then(function (result) {
                          $ionicLoading.show({
                              title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                              template: '{{"loading_login" | translate}}'
                          });
                            AuthServices.login(result.data.email, result.data.id, 2, token).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                        $rootScope.$broadcast('mt-user-logged');
                                          $rootScope.hideAuthModal();
                                          if(!$rootScope.authOnly)  $state.go($rootScope.authdest);
                                           if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else {
                                        $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );
                                    }
                                });
                        }, function (error) {
                            $cordovaDialogs.alert( response.msg, 'Autenticazione fallita.', 'OK' );
                          //   alert("There was a problem getting your profile.  Check the logs for details.");
                            //console.log(error);
                        });
                }, function (error) {
                    $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                });
        }

        function validateLogin(email, password){
          return !(!email || email === '' || !password || password === '' )
          //return email!='' && password!='' ;
        }
        function login(email, password, providerId) {

            if(!vm.validateLogin(email,password)){
                $cordovaDialogs.alert(  $interpolate("{{ 'data_insert_error'  | translate }}")($scope), 'Metooo', 'OK' );
                return;
            }
            $ionicLoading.show({
                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                template: '{{"loading_login" | translate}}'
            });

            AuthServices.login(email, password, providerId).
                then(function (response) {

                    $ionicLoading.hide();

                    if (response.state === 'OK') {
                        localStorage.setItem('user', JSON.stringify(response.user));
                        $rootScope.$broadcast('mt-user-logged');
                        $rootScope.hideAuthModal();
                          if(!$rootScope.authOnly)  $state.go($rootScope.authdest);
                           if($rootScope.authOnly) $rootScope.authOnly=false;
                    } else {
                        $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );
                    }

                }, function (error) {
                    $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                }

              );
        }

        function getLoggedUser() {
            return AuthServices.getLoggedUser();
        }
    };


    SignupController.$inject = ['$state','$rootScope', 'AuthServices',
        '$ionicLoading', '$cordovaOauth', '$http', '$ionicModal', '$scope', '$filter', '$cordovaDialogs', '$cordovaInAppBrowser','$interpolate'
    ];
    function SignupController($state, $rootScope, AuthServices, $ionicLoading, $cordovaOauth, $http, $ionicModal, $scope,  $filter, $cordovaDialogs, $cordovaInAppBrowser, $interpolate) {

        var vm = angular.extend(this, {
          signupWithEmail:false,

          register:register,
          login: login,
          fbLogin: fbLogin,
          linkedinAuth: linkedinAuth,
          googleAuth: googleAuth,
          openPrivacy:openPrivacy,
          email:'',
          password:'',
          showPassword:false
        });




        function openPrivacy(){
          // $state.go('authenticate.privacy');
          $rootScope.showPrivacy();
        }


        function googleAuth() {
            var token = "";
            $cordovaOauth.google("1016247754698.apps.googleusercontent.com", ["https://www.googleapis.com/auth/userinfo.profile", "https://www.googleapis.com/auth/userinfo.email"])
                .then(function (result) {
                    token = result.access_token;

                    $http.get("https://www.googleapis.com/oauth2/v3/userinfo", { params: { access_token: result.access_token } })
                        .then(function (result) {
                            $ionicLoading.show({
                                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                                template: '{{"loading_login" | translate}}'
                            });
                            AuthServices.login(result.data.email, result.data.sub, 3, token).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                        $rootScope.$broadcast('mt-user-logged');
                                          $rootScope.hideAuthModal();
                                         if(!$rootScope.authOnly)  $state.go($rootScope.authdest);
                                         if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else{
                                      vm.register(result.data.email, result.data.sub, 3, result.data.sub,token, {});
                                      //$cordovaDialogs.alert( response.msg, 'Autenticazione fallita.', 'OK' )
                                    }
                                },
                                function (err) {
                                    $cordovaDialogs.alert( err, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                                }
                              );
                        }, function (error) {
                            $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                        });
                }, function (error) {
                    $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                });
        }


        function linkedinAuth() {
            var token = "";
            $cordovaOauth.linkedin("gcevb22qvhxu", "kl18UhAIOQJqyXGx", ['r_emailaddress'], "dGCM6crUNkv6x6QW158a12R1QSydA15K")
                .then(function (result) {
                    token = result.access_token;
                    $http.get("https://api.linkedin.com/v1/people/~:(email-address,id,first-name,last-name)?oauth2_access_token=" + token + "&format=json")
                        .then(function (result) {
                            $ionicLoading.show({
                                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                                template: '{{"loading_login" | translate}}'
                            });
                            var anagrafic = {
                              "name" :   result.data.firstName,
                              "surname" :   result.data.lastName
                            }
                            AuthServices.login(result.data.emailAddress, result.data.id, 4, token.trim()).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                        $rootScope.$broadcast('mt-user-logged');
                                        $rootScope.hideAuthModal();
                                        if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                                        if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else{
                                      vm.register(result.data.emailAddress, result.data.id, 4,result.data.id, token, anagrafic);
                                      //$cordovaDialogs.alert( response.msg, 'Autenticazione fallita.', 'OK' )
                                    }
                                });
                        }, function (error) {
                            $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );


                        });
                }, function (error) {
                  $cordovaDialogs.alert( error, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                });
        }

        function fbLogin() {
            var token = "";
            $cordovaOauth.facebook("233646893428965", ["email"])
                .then(function (result) {
                    token = result.access_token;
                    $http.get("https://graph.facebook.com/v2.2/me", { params: { access_token: result.access_token, fields: "email", format: "json" } })
                        .then(function (result) {
                          $ionicLoading.show({
                              title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                              template: '{{"loading_login" | translate}}'
                          });
                            AuthServices.login(result.data.email, result.data.id, 2, token).
                                then(function (response) {
                                    $ionicLoading.hide();
                                    if (response.state === 'OK') {
                                        localStorage.setItem('user', JSON.stringify(response.user));
                                        $rootScope.$broadcast('mt-user-logged');
                                        $rootScope.hideAuthModal();
                                        if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                                        if($rootScope.authOnly) $rootScope.authOnly=false;
                                    } else{
                                      vm.register(result.data.email, result.data.id, 2, result.data.id, token,  {});
                                      //$cordovaDialogs.alert( response.msg, 'Autenticazione fallita.', 'OK' )
                                    }


                                });
                        }, function (error) {
                            $cordovaDialogs.alert( error, $interpolate("{{ 'auth_signup_failed'  | translate }}")($scope), 'OK' );
                        });
                }, function (error) {
                    $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_signup_failed'  | translate }}")($scope), 'OK' );

                });
        }

        function login(email, password, providerId) {

            $ionicLoading.show({
                title: $interpolate("{{ 'loading_login'  | translate }}")($scope) ,//'{{"loading_login" | translate}}',
                template: '{{"loading_login" | translate}}'
            });

            AuthServices.login(email, password, providerId).
                then(function (response) {

                    $ionicLoading.hide();

                    if (response.state === 'OK') {
                        localStorage.setItem('user', JSON.stringify(response.user));
                        $rootScope.$broadcast('mt-user-logged');
                        $rootScope.hideAuthModal();
                        if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                        if($rootScope.authOnly) $rootScope.authOnly=false;
                    } else{
                        $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_login_failed'  | translate }}")($scope), 'OK' );

                    }


                });
        }

        function register(email, password, provider_id, provider_uid, provider_token , data) {
          if (!email || email === '' || !password || password === '' ){
              $cordovaDialogs.alert(  $interpolate("{{ 'data_insert_error'  | translate }}")($scope), 'Metooo', 'OK' );
              return;
          }
            $ionicLoading.show({
                title: $interpolate("{{ 'loading_login'  | translate }}")($scope), //'{{"loading_login" | translate}}',
                template: '{{"loading_login" | translate}}'
            });

            AuthServices.register(email, password, provider_id, provider_uid, provider_token , data).
                then(function (response) {

                    $ionicLoading.hide();

                    if (response.state === 'OK') {
                        localStorage.setItem('user', JSON.stringify(response.user));
                        // $cordovaDialogs.alert( '', 'Registrazione avvenuta con successo', 'OK' );
                        $rootScope.$broadcast('mt-user-logged');
                        $rootScope.hideAuthModal();
                          if(!$rootScope.authOnly) $state.go($rootScope.authdest);
                           if($rootScope.authOnly) $rootScope.authOnly=false;
                    } else{
                      $cordovaDialogs.alert( response.msg, $interpolate("{{ 'auth_signup_failed'  | translate }}")($scope), 'OK' );

                    }


                });
        }

    }


    PwdRecController.$inject = ['$state', 'AuthServices',
        '$ionicLoading',  '$http', '$ionicModal', '$scope','$cordovaDialogs', '$filter', '$interpolate'
    ];
    function PwdRecController($state, AuthServices, $ionicLoading, $http, $ionicModal, $scope, $cordovaDialogs, $filter, $interpolate) {

      var vm = angular.extend(this, {
        recPass:recPass,
        email:''
      });

      function recPass(email) {
          if (!email || email === ''){
              $cordovaDialogs.alert( $interpolate("{{ 'pwdrec_insert_email'  | translate }}")($scope));
              return;
          }

          $ionicLoading.show({
              title: $interpolate("{{ 'loading_email'  | translate }}")($scope), //'{{"loading_email" | translate}}',
              template: '{{"loading_email" | translate}}'
          });

          AuthServices.recoveryPassword(email).then(
              function (response) {
                  $ionicLoading.hide();

                  if (response.state === 'OK') {
                      $cordovaDialogs.alert(  $interpolate("{{ 'loading_email_sent'  | translate }}")($scope),  $interpolate("{{ 'loading_email_sent'  | translate }}")($scope), 'OK' );
                      $state.go('authenticate',{tab:'login'});
                  } else{
                      $cordovaDialogs.alert( response.msg,  $interpolate("{{ 'auth_pwdrec_failed'  | translate }}")($scope), 'OK' );

                  }
              }
          );
      }


    }


})();
