(function () {
    'use strict';

    angular
    .module('events.module', [])

    .controller('EventsController',
        ['$state', 'AuthServices', 'EventsServices', '$ionicLoading', '$ionicHistory', '$cordovaDialogs', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','$ionicScrollDelegate','$timeout', '$interpolate',
        function ($state, AuthServices, EventsServices, $ionicLoading, $ionicHistory, $cordovaDialogs, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal, $ionicScrollDelegate, $timeout,$interpolate) {

            $scope.$on("$ionicView.beforeEnter", function(event, data){
                // vm.currentLocation = EventsServices.getLocationData();
                vm.exiting=false;
                // if(!vm.isFirstLoadDone){
                //   vm.applyFilter(vm.current_filter);
                // }
            });

            $scope.$on("$ionicView.afterEnter", function(event, data){
              vm.exiting=false;
                vm.currentLocation = EventsServices.getLocationData();
                if(!vm.currentLocation.isConsistent){
                  EventsServices.getCurrentPosition();
                }
                // vm.exiting=false;
                if(!vm.isFirstLoadDone){
                  vm.applyFilter(vm.current_filter);
                }
                $ionicHistory.clearHistory();
            });

            $scope.$on("$ionicView.beforeLeave", function(event, data){
                vm.exiting=true;
            });

            $scope.$on("mt-location-data-changed", function(event, data){
                vm.currentLocation = EventsServices.getLocationData();
                vm.applyFilter(vm.current_filter);
            });

            $scope.$on("mt-position-changed", function(event, data){
                vm.currentLocation = EventsServices.getLocationData();
            });


            var vm = angular.extend(this, {
              flyers:[],
              current_filter: null,
              applyFilter: applyFilter,
              loadEvents: loadEvents,
              loadMoreEvents: loadMoreEvents,
              isFirstLoadDone: false,
              isLoading: false,
              exiting: false,
              noMoreEvents: false,
              placeName: '...',
              // sidemenu:null,
              // openMenu:openMenu,
              // hideMenu:hideMenu,
              currentLocation: {placeName:'...',coords:null, isCurrentPosition:false},
              decodePrice: function(f){ return EventsServices.getTickedDecoded(f) },
              events_filters: EventsServices.createFilters(),
              doViewEvent: doViewEvent,
            });


            vm.current_filter = (vm.events_filters[0]);


            function doViewEvent(flyer){
                $state.go('main.events.detail',{id:flyer._id});
            }
            function applyFilter(f){
                $timeout(function () {
                    vm.current_filter.filter.page = 1;
                    f.filter.page=1;
                    vm.current_filter = f;
                    vm.noMoreEvents = false;
                    vm.loadEvents(vm.current_filter);
                }, 200);
            }

            function loadMoreEvents(f){
                if(vm.isLoading) return;
              vm.current_filter.filter.page = vm.current_filter.filter.page+1 ;
              vm.loadEvents( vm.current_filter);
            }

            function loadEvents(f){

              if(vm.isLoading) return;
              vm.isLoading = true;
              $ionicLoading.show({
                  title: 'Caricamento eventi',
                  template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
              });
              if(f.code!='P' && f.code!='B'){
                var l = vm.currentLocation;;
                if(l!==false){
                  f.filter.latitude = l.coords.latitude;
                  f.filter.longitude = l.coords.longitude;
                }
                f.filter.radius=20;
              }
              EventsServices.getFlyers(1, f.filter, f.code=='P').
                  then(function (response) {
                      $ionicLoading.hide();

                      vm.isFirstLoadDone = true;
                      $scope.$broadcast('scroll.infiniteScrollComplete');
                      if (response.state === 'OK') {

                          vm.noMoreEvents = f.code=='P' || response.flyers.length==0 || response.flyers.length<f.filter.count;

                          // vm.flyers = [];
                          var flyers = response.flyers ;

                          var a = '';
                          var d = null;
                          for (var i = 0; i < flyers.length; i++) {
                              if(d!=flyers[i].start_date.substr(0,10)){
                                flyers[i].hasDivider=true;
                                d = flyers[i].start_date.substr(0,10);
                              }
                              a = encodeURIComponent(flyers[i].style.background_image);
                              flyers[i].style.background_image = "" +a;

                              flyers[i].coords ={
                                 latitude:flyers[i].location.lat,
                                 longitude:flyers[i].location.lng
                              }
                           }
                           if(f.filter.page==1){
                              vm.flyers = [];
                                vm.flyers = flyers;
                                $ionicScrollDelegate.$getByHandle('events-scroll').scrollTop();
                           }else {
                              vm.flyers = vm.flyers.concat(flyers);;
                           }
                      }
                      else{
                        vm.noMoreEvents = true;
                        $cordovaDialogs.alert( $interpolate("{{ 'event_list_error'  | translate }}")($scope), 'Metooo' , 'OK' );

                      }

                      vm.isLoading = false;
                  },function(err){
                    $cordovaDialogs.alert( $interpolate("{{ 'event_list_server_error'  | translate }}")($scope), 'Metooo' , 'OK' );
                  });
            }



        }

      ])
      .controller('EventsDetailMapController', ['$state','uiGmapIsReady', '$stateParams', 'AuthServices', 'EventsServices', '$ionicLoading', '$cordovaDialogs', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi', '$interpolate',
          function ($state, uiGmapIsReady,$stateParams, AuthServices, EventsServices, $ionicLoading, $cordovaDialogs, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi, $interpolate) {


              $ionicLoading.show({
                  title: '',
                  template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
              });


              // var flyers = $stateParams.flyers ? $stateParams.flyers :[];
              var vm = angular.extend(this, {
                flyers: [],
                mapOpts: { center: p!==false ? p :{latitude:11,longitude:41}, zoom: 6 },
                map:null,
                pinOptions:{  url: 'img/mt-map-pin.png'},
                // isReadyMap:false,
              });
              uiGmapIsReady.promise(1).then(function(instances) {
                  instances.forEach(function(inst) {

                      // vm.map = inst.map;


                      $ionicLoading.hide();
                  });
              });
              uiGmapGoogleMapApi.then(function(maps) {
                  vm.mapOpts.center = {latitude:loc.latitude,longitude:loc.longitude};

                vm.pinOptions = {
                  url: 'img/mt-map-pin.png',
                  scaledSize: new google.maps.Size(37, 42),
                };

              });
              $scope.$on("mt-position-changed", function(event, data){
                // //$log.log(();
                vm.mapOpts.center = {};
                vm.mapOpts.center.latitude=data.latitude;
                vm.mapOpts.center.longitude=data.longitude;

              });
              $scope.$on("$ionicView.beforeEnter", function(event, data){
                 vm.flyers = $stateParams.flyers ? $stateParams.flyers :[];
              });



          }

      ])

      .controller('EventsMapController', ['$state','uiGmapIsReady', '$stateParams', 'AuthServices', 'EventsServices', '$ionicLoading', '$cordovaDialogs', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi', '$interpolate',
          function ($state, uiGmapIsReady,$stateParams, AuthServices, EventsServices, $ionicLoading, $cordovaDialogs, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi, $interpolate) {

              var p = EventsServices.getLastPosition();
              $ionicLoading.show({
                  title: '',
                  template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
              });


              // var flyers = $stateParams.flyers ? $stateParams.flyers :[];
              var vm = angular.extend(this, {
                flyers: [],
                mapOpts: { center: p!==false ? p :{latitude:11,longitude:41}, zoom: 6 },
                map:null,
                pinOptions:{  url: 'img/mt-map-pin.png'},
                // isReadyMap:false,
              });
              uiGmapIsReady.promise(1).then(function(instances) {
                  instances.forEach(function(inst) {

                      // vm.map = inst.map;


                      $ionicLoading.hide();
                  });
              });
              uiGmapGoogleMapApi.then(function(maps) {
                vm.map = maps;
                var loc = EventsServices.getLocationData();
                vm.mapOpts.center = {latitude:loc.latitude,longitude:loc.longitude};

                vm.pinOptions = {
                  url: 'img/mt-map-pin.png',
                  scaledSize: new google.maps.Size(37, 42),
                };

              });
              $scope.$on("mt-position-changed", function(event, data){
                // //$log.log(();
                vm.mapOpts.center = {};
                vm.mapOpts.center.latitude=data.latitude;
                vm.mapOpts.center.longitude=data.longitude;

              });
              $scope.$on("$ionicView.beforeEnter", function(event, data){
                 vm.flyers = $stateParams.flyers ? $stateParams.flyers :[];
              });

              $scope.goBack = function () {
                  $ionicHistory.goBack();
              }

          }

      ])


      .controller('EventDetailController', ['$state', '$sce', '$stateParams',  'AuthServices', 'uiGmapIsReady', '$cordovaCalendar', 'EventsServices', '$ionicLoading', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, $sce,$stateParams, AuthServices, uiGmapIsReady, $cordovaCalendar, EventsServices, $ionicLoading, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('EventDetailController');

              var view = '';
              $scope.encodeSRC = function(u){
                //$log.log(('encodeURI '+u);
                return encodeURIComponent(u);
              }
              $scope.trustSrc = function(src) {
                return $sce.trustAsResourceUrl(src);
              }


              var vm = angular.extend(this, {
                selectedEvent: {},
                mapOpts: { center: {"latitude":40.8261032,"longitude":14.18129799999997} , zoom: 6 },
                map:null,
                pinOptions:{ url: 'img/mt-map-pin.png'},
                view: view,
                changeView: changeView,
                encodeSRC:   $scope.encodeSRC,
                decodePrice: function(f){return EventsServices.getTickedDecoded(f);},
                addToCalendar:addToCalendar,
                goToPrevious:goToPrevious,
                selectedEventIsLoaded:false,
                showAllDesc:showAllDesc,
                closeAllDesc:closeAllDesc,
                backUISRef:{state:'',params:{}},
                doBuyTicket:doBuyTicket,
                doZoomMap:doZoomMap,
                closeZoomMap:closeZoomMap
              });

              function goToPrevious(){
                if(vm.backUISRef.state==''){
                  $ionicHistory.goBack();
                }else {
                  $state.go(vm.backUISRef.state, vm.backUISRef.params);
                }

              }

              function doBuyTicket(){
                $state.go('main.events.detail.buytickets',{id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
              }

              var zoomMapDlg= null;
              function doZoomMap(){
                $ionicModal.fromTemplateUrl(
                    'app/events/events-detail-map.html', {
                    id:'zoommap',
                    scope: $scope,
                    animation: 'slide-in-up',
                    backdropClickToClose:false
                }).then(function (modal) {
                    zoomMapDlg = modal;
                    zoomMapDlg.show();
                });
                // $state.go('main.events.detail.map',{id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent, mapOpts:vm.mapOpts});
              }
              function closeZoomMap(){
                zoomMapDlg.hide();

              }


              var allDsDlg = null;
              function showAllDesc(ds){
                $ionicModal.fromTemplateUrl(
                    'app/events/events-desc-all-modal.html', {
                    id:'alldesc',
                    scope: $scope,
                    animation: 'slide-in-up',
                    backdropClickToClose:false
                }).then(function (modal) {
                    allDsDlg = modal;
                    allDsDlg.show();
                });
              }
              function closeAllDesc(ds){
                allDsDlg.hide();

              }
              $scope.$on("$ionicView.afterEnter", function(event, data){
                vm.backUISRef = {state:'',params:{}};
                if($rootScope.backUISRef){
                  vm.backUISRef = $rootScope.backUISRef ;
                  $ionicHistory.clearHistory();
                  $rootScope.backUISRef = false;
                }
                if(angular.toJson(vm.selectedEvent)!='{}') return;


                $ionicLoading.show({
                    title: '',
                    template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                }).then(function(){

                    vm.isLoading = true;
                    var id = $stateParams.id ? $stateParams.id : 0;
                    if(id==0){
                      $state.go('main.events');
                      return;
                    }



                    // $ionicModal
                    EventsServices.getFlyerDetails(id).then(
                      function(response){

                        if(response.state=='OK'){
                           vm.view='info';
                          vm.selectedEvent= response.details;
                          var a = encodeURIComponent(vm.selectedEvent.style.background_image);
                          vm.selectedEvent.style.background_image = "" +a;

                          for (var i = 0; i < vm.selectedEvent.widgets.length; i++) {
                              var w = vm.selectedEvent.widgets[i];
                              if(w.name=='gallery' && w.draft==false){
                                try {
                                  for (var j = 0; j < w.data.entries.length; j++) {
                                    w.data.entries[j].src = ""+encodeURIComponent(w.data.entries[j].src);
                                  }
                                } catch (e) {
                                  $log.error(e+angular.toJson(w));
                                }
                              }
                          }
                          vm.selectedEventIsLoaded = true;
                          vm.mapOpts.center = {latitude:vm.selectedEvent.location.lat,longitude:vm.selectedEvent.location.lng};
                        }else{
                            $cordovaDialogs.alert( $interpolate("{{ 'event_list_error'  | translate }}")($scope)+":"+response.msg, 'Metooo' , 'OK' );
                        }

                        $ionicLoading.hide();

                      },
                      function(err){
                          $ionicLoading.hide();
                          $cordovaDialogs.alert( $interpolate("{{ 'event_list_server_error'  | translate }}")($scope), 'Metooo' , 'OK' );

                      }
                    );
                });
              });


              uiGmapGoogleMapApi.then(function(maps) {
                vm.map = maps;
                vm.pinOptions = {
                  url: 'img/mt-map-pin.png',
                  scaledSize: new google.maps.Size(37, 42),
                };
              });
              uiGmapIsReady.promise(1).then(function(instances) {
                try {
                  instances.forEach(function(inst) {

                      vm.map = inst.map;
                      vm.map.setCenter(new google.maps.LatLng(vm.mapOpts.center.latitude,vm.mapOpts.center.longitude));
                      vm.pinOptions = {
                        url: 'img/mt-map-pin.png',
                        scaledSize: new google.maps.Size(37, 42),
                      };

                  });
                } catch (e) {
                  $cordovaDialogs.alert( $interpolate("{{ 'event_list_map_error'  | translate }}")($scope), 'Metooo' , 'OK' );
                }

            });
            function addToCalendar(f){
              //$log.log(('addToCalendar');

              $cordovaDialogs.confirm($interpolate("{{ 'event_detail_add_to_calendar_confirm'  | translate }}")($scope), 'Metooo', [$interpolate("{{ 'event_detail_add_to_calendar_ok'  | translate }}")($scope), $interpolate("{{ 'cancel'  | translate }}")($scope)])
              .then(function(buttonIndex) {
                // no button = 0, 'OK' = 1, 'Cancel' = 2
                var btnIndex = buttonIndex;
                if(btnIndex==1){
                  var calEvent = {
                      title: f.title,
                      location: f.location.front_name,
                      notes: 'Metooo Event',
                      startDate: f.start_date,
                      endDate: f.end_date
                  }
                  try {
                    $cordovaCalendar.createEvent(calEvent).then(function (result) {
                          $cordovaDialogs.alert($interpolate("{{ 'event_detail_added_to_calendar'  | translate }}")($scope) );
                      }, function (err) {
                          $cordovaDialogs.alert($interpolate("{{ 'event_detail_added_to_calendar_error'  | translate }}")($scope) +err);
                      });
                  } catch (e) {
                    $cordovaDialogs.alert($interpolate("{{ 'event_detail_added_to_calendar_error'  | translate }}")($scope)+":"+e);
                  }
                }
              });

            }

            function changeView(v){
              $timeout(function () {
                vm.view = v;
              }, 200);
            }

          }


      ])



      .controller('EventsSearchController', ['$log', '$state', '$stateParams', '$ionicHistory','AuthServices', 'EventsServices', '$ionicLoading',  '$compile', '$scope',  '$rootScope',  '$ionicModal','$cordovaDatePicker','$timeout','$filter','$ionicPlatform','uiGmapGoogleMapApi', '$interpolate',
          function ($log, $state, $stateParams, $ionicHistory, AuthServices, EventsServices, $ionicLoading,  $compile, $scope,  $rootScope, $ionicModal,$cordovaDatePicker,$timeout , $filter, $ionicPlatform,uiGmapGoogleMapApi, $interpolate) {
              //$log.info('EventsSearchController');

              var locationData = EventsServices.getLocationData();

              var d1 = new Date();
              var d2 = new Date(d1.getFullYear(), d1.getMonth()+1, d1.getDate());
              var searchData = {
                text:'',
                place:{name:locationData.placeName, coords:{}},
                start_date:  d1,
                end_date: d2,
                initialized:false,

              };

              var vm = angular.extend(this, {
                userLogged: AuthServices.getLoggedUser()!=undefined ? true : false,
                searchData:searchData,
                locationData:locationData,
                doSearch:doSearch,
                flyers:[],
                showDatePicker:showDatePicker,
                autocompletePlace:null,
                autocompleteService:null,
                showPlaceList:false,
                placeNameChanged:placeNameChanged,
                selectPlace:selectPlace,
                autocompleteList:[],
                doTogglePlaceList:doTogglePlaceList,
                placeListTop :'120px',
                decodePrice: function(f){return EventsServices.getTickedDecoded(f);},
              });

              $scope.$on("$ionicView.beforeEnter", function(event, data){
                //$log.log(('EventsSearchPlaceController:beforeEnter');

                uiGmapGoogleMapApi.then(function(maps) {

                  if(vm.autocompleteService==null){
                      vm.autocompleteService = new google.maps.places.AutocompleteService();
                  }

                });
                vm.locationData = angular.copy(EventsServices.getLocationData());

                if(!vm.searchData.initialized){
                  vm.searchData.place.name = vm.locationData.placeName;
                  vm.searchData.place.coords = vm.locationData.coords;
                  vm.searchData.initialized = true;
                }
              });


              $scope.$on("$ionicView.afterEnter", function(event, data){
                  uiGmapGoogleMapApi.then(function(maps) {
                   vm.placeNameChanged(vm.searchData.place.name);
                  });
              });


              function doTogglePlaceList(ev, v){
                //$log.log(('doTogglePlaceList:'+v);
                // vm.placeListTop = '120px';
                $timeout(function () {
                    vm.showPlaceList = v;
                    if(!v)vm.autocompleteList=[];
                }, 200);
              }
              function placeNameChanged(txt){

                //$log.log(('placeNameChanged:'+txt);
                if(txt.length==0) return;

                var options = {
                  language:'it',
                  types: ['(cities)']
                };

                vm.autocompleteList=[];
                vm.autocompleteService.getPlacePredictions({ input: txt,  language:'it', types: ['(cities)'] },
                  function(predictions, status) {
                      // //$log.log(('placeNameChanged:'+txt+ 'list');
                      if (status != google.maps.places.PlacesServiceStatus.OK) {
                        $cordovaDialogs.alert(status);
                        return;
                      }

                      $timeout(function () {
                        predictions.forEach(function(prediction) {
                          // //$log.log(('placeNameChanged:'+txt+ 'list'+prediction.description);
                          vm.autocompleteList.push(prediction);

                        });
                      }, 100);
                  }
                );
              }

              function selectPlace(placeId, name){
                  vm.searchData.place.name = name;
                  var service = new google.maps.places.PlacesService(document.createElement('div'));
                  service.getDetails({ placeId: placeId },
                      function(place, status) {
                          if (status === google.maps.places.PlacesServiceStatus.OK) {
                             if (!place.geometry) {
                                $cordovaDialogs.alert ($interpolate("{{ 'coordinate_not_found'  | translate }}")($scope));
                                return;
                              }
                              vm.searchData.place.coords = {latitude:place.geometry.location.lat(),longitude:place.geometry.location.lng()};;
                              // vm.locationSearchData.coords={latitude:place.geometry.location.lat(),longitude:place.geometry.location.lng()};
                          }
                      }
                  );
              }


              function showDatePicker(searchData, sKey){
                  //$log.info('EventsSearchController:showDatePicker');
                  document.addEventListener("deviceready", function () {
                    //$log.info('EventsSearchController:showDatePicker ...');
                    var options = {
                      date: (angular.isDate(searchData[sKey])) ? searchData[sKey] : new Date(),
                      mode: 'date', // or 'time'
                      // minDate: new Date() - 10000,
                      // allowOldDates: true,
                      // allowFutureDates: true,
                      // doneButtonLabel: 'OK',
                      // doneButtonColor: '#F2F3F4',
                      // cancelButtonLabel: 'CANCEL',
                      // cancelButtonColor: '#000000'
                    };
                    function onSuccess(date) {
                      //  //$log.info('EventsSearchController:showDatePicker then'+angular.toJson(searchData));

                        $timeout(function () {
                          searchData[sKey] = date;
                          // //$log.info('EventsSearchController:showDatePicker then'+date+'='+angular.toJson(searchData[sKey]));
                        }, 100);
                    }
                    function onError(error) { // Android only
                        $log.error('Error: ' + error);
                    }

                    datePicker.show(options, onSuccess, onError);

                  }, false);
              }


              function doSearch(searchData){
                $ionicPlatform.ready(function () {
                    if (window.cordova && window.cordova.plugins.Keyboard) {
                        cordova.plugins.Keyboard.close();
                    }
                });

                // alert('doSearch');return;

                try {
                  var filt = { radius:20 , page:1, count:12,x:1};

                  if(vm.searchData.text!='') filt.text = vm.searchData.text;
                  if(vm.searchData.place.coords) {
                    filt.latitude = vm.searchData.place.coords.latitude;
                    filt.longitude = vm.searchData.place.coords.longitude;
                  }

                  filt.start_date = (vm.searchData.start_date!=null) ? EventsServices.format_iso8601(searchData.start_date,0 ) : "";
                  filt.end_date = (vm.searchData.end_date!=null) ? EventsServices.format_iso8601(searchData.end_date,0 ) : "";

                  // latitude: 40.6491886,
                  // longitude: 14.611711199999945,
                  //  radius: 20,
                  // text: 'violin',

                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });
                    console.info('searchevents '+angular.toJson(filt));

                  EventsServices.getFlyers(1, filt, false).
                      then(function (response) {

                          $ionicLoading.hide();
                          vm.isLoading = false;
                          vm.isFirstLoadDone = true;
                          $scope.$broadcast('scroll.infiniteScrollComplete');
                          if (response.state === 'OK') {

                              vm.noMoreEvents = response.flyers.length==0 || response.flyers.length<filt.count;

                              var flyers = response.flyers ;

                              var a='';
                              var d = null;
                              for (var i = 0; i < flyers.length; i++) {
                                  if(d!=flyers[i].start_date.substr(0,10)){
                                    flyers[i].hasDivider=true;
                                    d = flyers[i].start_date.substr(0,10);
                                  }
                                  // a = encodeURIComponent(vm.flyers[i].style.background_image);
                                  // vm.flyers[i].style.background_image = "https://api.metooo.io/img/360/195/" + a;
                                   a = encodeURIComponent(flyers[i].style.background_image);
                                   flyers[i].style.background_image = "" +a;

                                   flyers[i].coords ={
                                     latitude:flyers[i].location.lat,
                                     longitude:flyers[i].location.lng
                                   }

                               }
                               vm.flyers = filt.page==1 ? flyers : vm.flyers.concat(flyers);;
                          }
                          else{
                              vm.noMoreEvents = true;
                              $cordovaDialogs.alert(  $interpolate("{{ 'event_list_error'  | translate }}")($scope), 'Metooo', 'OK' );
                          }
                      });
                } catch (e) {
                  // alert(e);
                    $cordovaDialogs.alert(  $interpolate("{{ 'event_list_error'  | translate }}")($scope)+":"+e, 'Metooo', 'OK' );
                }

              }

          }

      ])

      .controller('TicketsDetailController', ['$state', '$stateParams',  'AuthServices', 'uiGmapIsReady', '$cordovaCalendar', 'EventsServices', '$ionicLoading', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi','$cordovaDialogs', '$timeout', '$log','ENV','$base64', '$interpolate',
          function ($state, $stateParams, AuthServices, uiGmapIsReady, $cordovaCalendar, EventsServices, $ionicLoading, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi,$cordovaDialogs, $timeout, $log, ENV, $base64, $interpolate) {
              //$log.log(('TicketsDetailController');

              var vm = angular.extend(this, {
                selectedOrder: {},
                selectedTicket:{},
                selectedAttendees:{},
                isLoading:false,
                qrCodeURL : '',
                qrCodeData: ''
              });
              // $scope.qrcode = '000';
              // $scope.qrcode = '4aaassAA4444'.toUpperCase();
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }
                vm.selectedTicket = $stateParams.selectedTicket ? $stateParams.selectedTicket : {};
                vm.selectedOrder = $stateParams.selectedOrder ? $stateParams.selectedOrder : {};
                vm.selectedAttendees = $stateParams.selectedAttendees ? $stateParams.selectedAttendees : {};
                if( vm.selectedOrder.ticket){
                  EventsServices.getQRCode64(vm.selectedOrder._id, vm.selectedAttendees._id)
                  .then (
                    function(response){
                      if(response.state=='OK'){
                         vm.qrCodeData = response.qrcode64;
                      }else{
                        $cordovaDialogs.alert(  $interpolate("{{ 'my_tickets_qrcode_error'  | translate }}")($scope)+':'+response.msg, 'Metooo', 'OK' );
                      }

                    },
                    function(err){
                        $cordovaDialogs.alert(  $interpolate("{{ 'my_tickets_qrcode_error'  | translate }}")($scope)+':'+err, 'Metooo', 'OK' );
                    }
                  );
                }




              });
          }
      ])
      .controller('EventsSearchPlaceController', ['$state', '$stateParams', 'AuthServices', 'EventsServices', '$ionicLoading', '$cordovaDialogs','$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi', '$timeout', '$log', '$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$cordovaDialogs, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi, $timeout, $log, $interpolate) {




              var vm = angular.extend(this, {
                userLogged: AuthServices.getLoggedUser()!=undefined ? true : false,
                locationData:{},
                locationSearchData:{},
                setLocationData:setLocationData,
                getPosition:getPosition,
                autocompleteService:null,
                placeService:null,
                autocompleteList:[],
                placeNameChanged:placeNameChanged,
                selectPlace:selectPlace,
                resetSearch:resetSearch,
                selectingCurrentPosition:false
              });

              $scope.$on("mt-place-changed", function(event, data){
                $timeout(function () {

                  vm.locationData.placeName= data;

                }, 100);

              });
              $scope.$on("mt-position-changed", function(event, data){

                $timeout(function () {
                    vm.locationData.coords = data;
                }, 100);
              });

              $scope.$on("$ionicView.beforeEnter", function(event, data){

                  uiGmapGoogleMapApi.then(function(maps) {
                    // if (status != google.maps.places.PlacesServiceStatus.OK) {
                    //   alert(status);
                    //   return;
                    // }
                    if(vm.autocompleteService==null){
                        vm.autocompleteService = new google.maps.places.AutocompleteService();
                    }
                    // if(vm.placeService==null){
                    //     vm.placeService = new google.maps.places.PlacesService();
                    // }
                    // vm.placeNameChanged(vm.locationSearchData.placeNameSearch);
                  });
                  vm.locationData = angular.copy(EventsServices.getLocationData());
                  vm.locationSearchData = angular.copy(vm.locationData);
                  vm.locationSearchData.placeNameSearch = vm.locationSearchData.placeName;

              });
              $scope.$on("$ionicView.afterEnter", function(event, data){

                  uiGmapGoogleMapApi.then(function(maps) {

                   vm.placeNameChanged(vm.locationSearchData.placeNameSearch);
                  });


              });

              // var displaySuggestions = ;

              function placeNameChanged(txt){

                //$log.log(('placeNameChanged:'+txt);
                if(txt.length==0) return;

                var options = {
                  language:'it',
                  types: ['(cities)']
                };
                vm.autocompleteList=[];
                vm.autocompleteService.getPlacePredictions({ input: txt,  language:'it', types: ['(cities)'] },
                  function(predictions, status) {
                      //$log.log(('placeNameChanged:'+txt+ 'list');
                      if (status != google.maps.places.PlacesServiceStatus.OK) {
                        $cordovaDialogs.alert(status);
                        return;
                      }

                      $timeout(function () {
                        predictions.forEach(function(prediction) {
                          $log.log('placeNameChanged:'+txt+ ' list '+angular.toJson(prediction));
                          prediction.label = prediction.terms[0].value;
                          vm.autocompleteList.push(prediction);

                        });
                      }, 100);


                  }
                );
              }

              function selectPlace(placeId, name){
                vm.locationSearchData.placeNameSearch=name;
                var service = new google.maps.places.PlacesService(document.createElement('div'));
                  service.getDetails({ placeId: placeId },
                      function(place, status) {
                          if (status === google.maps.places.PlacesServiceStatus.OK) {

                             if (!place.geometry) {
                                $cordovaDialogs.alert(  $interpolate("{{ 'coordinate_not_found'  | translate }}")($scope), 'Metooo', 'OK' );
                                return;
                              }
                              //EventsServices.decodeAddress(place);
                              vm.locationSearchData.coords={latitude:place.geometry.location.lat(), longitude:place.geometry.location.lng()};
                              vm.setLocationData(vm.locationSearchData);
                          }
                      }
                  );
              }

              function resetSearch(){
                  vm.locationSearchData.placeNameSearch='';
                  vm.autocompleteList=[];
                  var ctrl = document.querySelector( '#place-search-input-autocomplete' );
                  ctrl.focus();
              }



              $scope.$on("mt-location-data-changed", function(event, data){
                //$log.log(("mt-location-data-changed");
                  vm.locationData = data;
                  vm.locationSearchData = data;
                  vm.locationSearchData.placeNameSearch = vm.locationSearchData.placeName;
              });

              function setLocationData(data){
                EventsServices.setLocationData(data.placeNameSearch,data.coords.latitude,data.coords.longitude);
                $state.go('main.events')
              }
              function getPosition(){
                $ionicLoading.show({
                    title: '',
                    template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                });
                vm.selectingCurrentPosition = true;
                EventsServices.getCurrentPositionNoUpdate().then(function (position) {

                  EventsServices.getCurrentPlaceNamePromise(position.coords, false).then(
                    function(data){
                        vm.setLocationData({
                          placeNameSearch:data,
                          coords:{latitude:position.coords.latitude, longitude:position.coords.longitude}
                        });
                        $ionicLoading.hide();
                    },
                    function(err){
                        $ionicLoading.hide();

                        $cordovaDialogs.alert(  $interpolate("{{ 'position_error'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );
                    }
                  );


                }, function(err) {
                  $ionicLoading.hide();
                  $cordovaDialogs.alert(  $interpolate("{{ 'position_error'  | translate }}")($scope)+":"+err.message, 'Metooo', 'OK' );
                });
              }
          }

      ])

      .controller('TicketsController', ['$state', '$stateParams',  'AuthServices', 'uiGmapIsReady', '$cordovaCalendar', 'EventsServices', '$ionicLoading', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, $stateParams, AuthServices, uiGmapIsReady, $cordovaCalendar, EventsServices, $ionicLoading, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('TicketsController');


              var vm = angular.extend(this, {
                tickets: [],
                isLoading:false,
                page:0,
                loadUserTickets:loadUserTickets,
                existsMoreTickets:true,
                loadTickets:loadTickets,
                loadMoreTickets:loadMoreTickets,
                lastuserid:'',
                isFirstLoadDone:false

              });

              $scope.$on("$ionicView.beforeEnter", function(event, data){
                  if(AuthServices.getLoggedUser()==undefined ){
                    $state.go('main.events');
                    return;
                  }
                  if(vm.lastuserid!=AuthServices.getLoggedUser()._id){
                      vm.lastuserid = AuthServices.getLoggedUser()._id;
                      vm.loadTickets();
                  }
                  // if(vm.tickets.length==0){

                  // }
              });

              function loadUserTickets(page){
                //$log.log(('loadUserTickets page '+page);
                if(vm.isLoading) return;

                $ionicLoading.show({
                    title: ' ',
                    template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                }).then(function(){
                    vm.isLoading = true;
                    if(AuthServices.getLoggedUser()==undefined){
                      $state.go('main.events');
                      return;
                    }
                    // $ionicModal
                    EventsServices.getUserTickets(page).then(
                      function(response){
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                        if(response.state=='OK'){
                          vm.existsMoreTickets = (response.data.length>0);

                          var tlist = response.data;
                          for (var i = 0; i < tlist.length; i++) {
                            tlist[i].flyer.style.background_image =  encodeURIComponent(tlist[i].flyer.style.background_image);
                            //   vm.selectedEvent.style.background_image = "" +a;.length<2){
                            //     tlist[i].nextstate =
                            // }
                          }
                          if(page==1){
                            vm.tickets = tlist;
                          }else {
                            vm.tickets = vm.tickets.concat(tlist);
                          }

                        }else{
                          $scope.existsMoreTickets = false;
                          $cordovaDialogs.alert(  $interpolate("{{ 'server_data_error'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );
                        }
                        vm.isLoading = false;
                        vm.isFirstLoadDone = true;
                        $ionicLoading.hide();
                      },
                      function(err){
                        $scope.existsMoreTickets = false;
                          $ionicLoading.hide();
                          $cordovaDialogs.alert(  $interpolate("{{ 'server_data_error'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );

                      }
                    );
                });
              }

              function loadMoreTickets(){
                //$log.log(('loadMoreTickets');
                vm.page++;
                vm.loadUserTickets(vm.page);
              };

              function loadTickets (){

                //$log.log(('loadTickets');
                vm.page=1;
                $scope.existsMoreTickets = true;
                vm.loadUserTickets(vm.page);
              }

                // vm.loadTickets();

          }
      ])

      .controller('TicketsListController', ['$state', '$stateParams',  'AuthServices', 'uiGmapIsReady', '$cordovaCalendar', 'EventsServices', '$ionicLoading', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, $stateParams, AuthServices, uiGmapIsReady, $cordovaCalendar, EventsServices, $ionicLoading, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('TicketsListController');

              var vm = angular.extend(this, {
                selectedTicket: {},
                isLoading:false,

              });


              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined || !$stateParams.selectedTicket){
                  $state.go('main.events');
                  return;
                }
                vm.selectedTicket = $stateParams.selectedTicket ? $stateParams.selectedTicket : {};
                if( vm.selectedTicket.orders[0].attendees_data.length==1){
                  EventsServices.getQRCode64(vm.selectedTicket.orders[0]._id, vm.selectedTicket.orders[0].attendees_data[0]._id)
                  .then (
                    function(response){
                      if(response.state=='OK'){
                         vm.qrCodeData = response.qrcode64;
                      }else{
                        $cordovaDialogs.alert(  $interpolate("{{ 'my_tickets_qrcode_error'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );

                      }

                    },
                    function(err){
                        $cordovaDialogs.alert(  $interpolate("{{ 'my_tickets_qrcode_error'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );
                    }
                  );
                }

              });



          }
      ])

      .controller('EventBuyTicketsController', ['$state', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('EventBuyTicketsController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                tickets: [],
                discountCode:'',
                decQty: function(t){if(t.qty>0) t.qty--;},
                incQty: function(t){if(t.qty<t.max_quantity) t.qty++;},
                checkForProceed: checkForProceed,
                doProceed: doProceed,
                showAllDesc: showAllDesc,
                closeAllDesc: closeAllDesc,
                checkDiscountCode: checkDiscountCode,
                checkEndDate: checkEndDate,

              });


              function checkEndDate(d) {
                var dt = new Date(d);dt.setHours(0,0,0,0)
                var td = new Date();td.setHours(0,0,0,0)


                return (dt.getTime()>=td.getTime());

              }
              var allDsDlg = null;
              function showAllDesc(ds){
                $ionicModal.fromTemplateUrl(
                    'app/events/events-ticket-desc-all-modal.html', {
                    id:'alldesc',
                    scope: $scope,
                    animation: 'slide-in-up',
                    backdropClickToClose:false
                }).then(function (modal) {
                    allDsDlg = modal;
                    allDsDlg.show();
                });
              }
              function closeAllDesc(ds){
                allDsDlg.hide();
              }


              function checkDiscountCode(_id, code){
                  if(code.trim()==''){
                    return;
                  }
                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });
                  EventsServices.checkDiscountCode(_id,code).then(
                      function(response){
                        $ionicLoading.hide();
                        if(response.state=='OK'){
                            var discounts = response.data;
                            if(discounts.length>0){
                              for (var d = 0; d < discounts.length; d++) {
                                  var discount = discounts[d];

                                  for (var i = 0; i < vm.tickets.length; i++) {
                                      var t = vm.tickets[i];
                                      if(t._id==discount.ticket_id){
                                          t.has_discount = true;
                                          t.discount= discount;
                                          break;
                                      }
                                  }
                              }
                            }else{
                              $cordovaDialogs.alert(  $interpolate("{{ 'buy_tickets_no_discount'  | translate }}")($scope), 'Metooo', 'OK' );
                            }


                        }else{
                            $cordovaDialogs.alert(  $interpolate("{{ 'buy_tickets_no_discount_err'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );
                        }
                      },
                      function(err){
                          $ionicLoading.hide();
                          $cordovaDialogs.alert(  $interpolate("{{ 'buy_tickets_no_discount_err'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );
                      }
                  );
              }

              function checkForProceed(){
                  if(AuthServices.getLoggedUser()==undefined){
                      $rootScope.authOnly = true;
                      $rootScope.doShowAuthModalExt('login',$scope, function(){
                        if(AuthServices.getLoggedUser()==undefined){
                          $cordovaDialogs.alert(  $interpolate("{{ 'login_to_proceed'  | translate }}")($scope), 'Metooo', 'OK' );
                          return;
                        }
                        vm.doProceed();
                      });
                  }else{
                      vm.doProceed();
                  }
              }

              function getOrderByTicketId(tid){
                  for (var i = 0; i < vm.dataOut.length; i++) {
                    var o = vm.dataOut[i];
                    if(o.ticket._id==tid){
                      return o;
                    }
                  }
                  return null;
              }


              function doProceed(){

                  if(AuthServices.getLoggedUser()==undefined){
                    $cordovaDialogs.alert(  $interpolate("{{ 'login_to_proceed'  | translate }}")($scope), 'Metooo', 'OK' );
                    return;
                  }

                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });

                  var ticketsToBuy= [];
                  var n = 0.0;
                  for (var i = 0; i < vm.tickets.length; i++) {
                      if(vm.tickets[i].qty>0){
                        ticketsToBuy.push({
                            _id: vm.tickets[i]._id,
                            discount_code: vm.tickets[i].has_discount ? vm.tickets[i].discount._id : '' ,
                            quantity: vm.tickets[i].qty
                        })
                      }
                      n = n + vm.tickets[i].qty;
                  }
                  if(n==0){
                      $ionicLoading.hide();
                      $cordovaDialogs.alert(  $interpolate("{{ 'no_tickets_selected'  | translate }}")($scope), 'Metooo', 'OK' );
                      return;
                  }

                  var reqdata = {id_event:vm.selectedEvent._id, tickets:ticketsToBuy};
                  EventsServices.postBlockTickets(reqdata).then(
                      function(response){
                        $ionicLoading.hide();
                        if(response.state=='OK'){

                          $state.go('main.events.detail.buytickets.assign', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent, orders: response.data});

                        }else{
                          $cordovaDialogs.alert(  $interpolate("{{ 'order_error'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );

                        }
                      },
                      function(err){
                          $ionicLoading.hide();
                          $cordovaDialogs.alert(err);
                      }
                  );

              }

              $scope.$on("$ionicView.beforeEnter", function(event, data){
                  vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                  if('{}'===angular.toJson(vm.selectedEvent)){
                    $state.go('main.events', true);
                    return;
                  }
                   vm.tickets = angular.copy(vm.selectedEvent.tickets);
                  for (var i = 0; i < vm.tickets.length; i++) {
                    if(!vm.tickets[i].qty)  vm.tickets[i].qty = 0;
                  }

              });

          }
      ])

      .controller('EventBuyTicketsAssignController', ['$state', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log', '$ionicHistory','$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $ionicHistory, $interpolate) {
              //$log.log(('EventBuyTicketsAssignController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orders: [],
                totals:{},
                currentOrderIndex:0,
                currentAttendeeIndex:0,
                currentOrder:{},
                currentState:0,
                loadNextTicket:loadNextTicket,
                countDownTimer : null,
                startCountDown:startCountDown,
                validateAttendee:validateAttendee,
                doProceed:doProceed,
                existSurvey:false,
                currentProgressIndex:0,
                hasDataOut: false,
                dataOut: null,
                goBack: goBack,
                resetData: resetData
              });


              function resetData(){
                vm.orders = [];
                vm.selectedEvent = [];
                vm.totals = {};
              }
              function goBack(){

                $cordovaDialogs.confirm($interpolate("{{ 'confirm_order_cancel'  | translate }}")($scope), 'Metooo', [$interpolate("{{ 'proceed'  | translate }}")($scope),$interpolate("{{ 'cancel'  | translate }}")($scope)])
                .then(function(buttonIndex) {
                  // no button = 0, 'OK' = 1, 'Cancel' = 2
                  var btnIndex = buttonIndex;

                  if(btnIndex==1){
                    EventsServices.deleteOrder(vm.orders[0].trnx_id).then(
                        function(response) {
                            vm.resetData();
                            $ionicHistory.goBack();
                        },function(err) {
                            $cordovaDialogs.alert($interpolate("{{ 'order_cancel_error'  | translate }}")($scope)+err, "Metooo", "OK");
                        }

                    );
                  }

                });
              }
              function validateAttendee(t, o){
                var retval = t.name!='' && t.surname!='' && t.email!='' && EventsServices.validateEMail(t.email);

                if(retval){//se dati minimi ok controllo su aggiuntivi
                  if(o.survey && o.survey.entries && o.survey.entries.length>0){
                    for (var i = 0; i < o.survey.entries.length; i++) {
                      var s = o.survey.entries[i];
                      if (s.required){

                        if (s.type=="checkbox" && s.has_opts ){
                          for (var j = 0; j < s.opts.length;j++) {
                            var o = s.opts[i];
                            if(t.survey && t.survey['field_'+i] && t.survey['field_'+i]['opts']){
                               var ok = false;
                               for (var c = 0; c < array.length; c++) {
                                 if( t.survey['field_'+i]['opts'][c]!=''){
                                    ok=true; break;
                                 }
                               }
                               return ok;
                            }else return false;
                          }
                        }else if(!t.survey || !t.survey['field_'+i] || t.survey['field_'+i]==''){
                          return false;
                        }

                      }
                    }
                  }
                }
                return retval;
              }

              function doProceed(){
                if(vm.validateAttendee(vm.currentOrder.attendees[vm.currentAttendeeIndex-1], vm.currentOrder)){
                  if(vm.currentOrderIndex<vm.orders.length || vm.currentAttendeeIndex<vm.currentOrder.quantity){
                    vm.loadNextTicket()
                  }else{
                      vm.hasDataOut = true;
                      vm.dataOut = vm.orders;

                      if(vm.totals.total>0){
                        $state.go('main.events.detail.buytickets.assign.pay',{
                          id:vm.selectedEvent._id,
                          selectedEvent:vm.selectedEvent,
                          orders:vm.orders,
                          totals:vm.totals
                        });
                      }else {
                        $state.go('main.events.detail.buytickets.assign.pay.free',{
                          id:vm.selectedEvent._id,
                          selectedEvent:vm.selectedEvent,
                          orders:vm.orders,
                          totals:vm.totals
                        });
                      }
                  }
                }else {
                    $cordovaDialogs.alert($interpolate("{{ 'order_attendee_input_error'  | translate }}")($scope), "Metooo", "OK");
                }
              }

              function startCountDown(){
                vm.countDownTimer = $timeout(function () {
                  if(vm.totals.time.s>0){
                    vm.totals.time.s--;
                  }else{
                    vm.totals.time.s = 59;
                    if(vm.totals.time.m>0){
                      vm.totals.time.m--;
                    }else{
                      $timeout.cancel(vm.countDownTimer);
                      vm.countDownTimer = null;

                      $cordovaDialogs.alert($interpolate("{{ 'time_expired'  | translate }}")($scope), "Metooo", "OK");
                      $state.go('main.events.detail.buytickets', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
                      return;
                    }
                  }
                  vm.startCountDown();
                }, 1000);
              }

              function loadNextTicket(){

                if(vm.currentOrderIndex<vm.orders.length || vm.currentAttendeeIndex<vm.currentOrder.quantity){
                  // va avanti con attendee se nn complteati
                  vm.currentProgressIndex++;
                  if (vm.currentAttendeeIndex<vm.currentOrder.quantity){
                    vm.currentAttendeeIndex++;
                  }else{
                    vm.currentOrderIndex++;
                    vm.currentOrder = vm.orders[vm.currentOrderIndex-1];
                    if(!vm.currentOrder.attendees){
                      vm.currentOrder.attendees = [];
                    }
                    while (vm.currentOrder.quantity >  vm.currentOrder.attendees.length){
                      if(vm.currentProgressIndex==1 &&  vm.currentOrder.attendees.length==0 && AuthServices.getLoggedUser()!=undefined ){
                        var u = AuthServices.getLoggedUser();
                        vm.currentOrder.attendees.push({name:u.anagraphics.name,surname:u.anagraphics.surname,email:u.credential.email})
                      }else{

                        vm.currentOrder.attendees.push({name:'',surname:'',email:''})
                      }

                    }
                      vm.currentAttendeeIndex=1;
                  }
                }

              }

              function calcTotals(){
                var q = 0;
                var v = 0.0;
                for (var i = 0; i < vm.orders.length; i++) {
                  q += vm.orders[i].quantity;
                  v += vm.orders[i].payment.amount;
                }
                vm.totals = {total:v, numtickets:q, time: ( !vm.totals.time ? {m:8,s:0} : vm.totals.time) };
              }

              $scope.$on("$ionicView.beforeLeave", function(event, data){
                  if(  vm.countDownTimer != null){
                      $timeout.cancel(vm.countDownTimer);
                  }
              });

              $scope.$on("$ionicView.beforeEnter", function(event, data){
                  if(AuthServices.getLoggedUser()==undefined){
                    $state.go('main.events');
                    return;
                  }

                  vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                  if('{}'==angular.toJson(vm.selectedEvent)){
                    $state.go('main.events', true);
                    return;
                  }

                  if(!vm.hasDataOut){
                    vm.orders = $stateParams.orders ? angular.copy($stateParams.orders) : {};
                    if(vm.orders.length>0){
                      calcTotals();
                      vm.loadNextTicket();
                      vm.startCountDown();
                    }else{
                      $cordovaDialogs.alert('Nessun ordine ricevuto');
                    }
                  }else{
                    vm.currentOrderIndex = 1;
                    vm.currentAttendeeIndex = 1 ;
                    vm.currentProgressIndex = 1;
                    vm.orders = vm.dataOut;
                  }
              });

          }
      ])

      .controller('EventBuyTicketsPayController', ['$state', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log','$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('EventBuyTicketsPayController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orders: [],
                totals: {},
                currentTicketIndex: 0,
                currentTicket: {},
                currentState: 0,
                countDownTimer : null,
                startCountDown: startCountDown,
                gotoPay:gotoPay,

              });




              function startCountDown(){
                vm.countDownTimer = $timeout(function () {
                  if(vm.totals.time.s>0){
                    vm.totals.time.s--;
                  }else{
                    vm.totals.time.s = 59;
                    if(vm.totals.time.m>0){
                      vm.totals.time.m--;
                    }else{
                      $timeout.cancel(vm.countDownTimer);
                      vm.countDownTimer = null;
                        $cordovaDialogs.alert($interpolate("{{ 'time_expired'  | translate }}")($scope), "Metooo", "OK");
                      $state.go('main.events.detail.buytickets', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
                      return;
                    }
                  }
                  vm.startCountDown();
                }, 1000);
              }

              function gotoPay(tp){
                $state.go('main.events.detail.buytickets.assign.pay.'+tp,{selectedEvent:vm.selectedEvent, orders:vm.orders, totals:vm.totals});
              }


              $scope.$on("$ionicView.beforeLeave", function(event, data){
                if(  vm.countDownTimer != null){
                    $timeout.cancel(vm.countDownTimer);
                }
              });
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.orders = $stateParams.orders ? $stateParams.orders : {};
                vm.totals = $stateParams.totals ? $stateParams.totals : {};

                vm.startCountDown();

              });

          }
      ])

      .controller('EventBuyTicketsPayStripeController', ['$state', 'ENV', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, ENV, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('EventBuyTicketsPayController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orders: [],
                totals: {},
                currentTicketIndex: 0,
                currentTicket: {},
                currentState: 0,
                countDownTimer : null,
                startCountDown: startCountDown,
                payWithStripe: false,
                doPayWithStripe: doPayWithStripe,
                payWithPayPal: false,
                ccdata: {n:'','m':'',y:'',c:''},
                trnx_id:'',
                validateCCData: validateCCData
              });



              function validateCCData(){
                return  vm.ccdata.n!='' && vm.ccdata.m!='' && vm.ccdata.y!='' && vm.ccdata.c!='';
              }
              function doPayWithStripe(tp){
                if(!vm.validateCCData()){
                  return
                }
                $ionicLoading.show({
                    title: ' ',
                    template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                });
                Stripe.setPublishableKey(ENV.stripePublicKey);
                Stripe.card.createToken({
                    number: vm.ccdata.n,
                    exp_month: vm.ccdata.m,
                    exp_year: vm.ccdata.y,
                    cvc: vm.ccdata.c
                  },
                  function(status, response) {
                      $ionicLoading.hide();
                      if (response.error) { // Problem!
                        $cordovaDialogs.alert($interpolate("{{ 'stripe_error'  | translate }}")($scope)+":"+response.error.message, "Metooo", "OK");
                    //    $cordovaDialogs.alert("problemi durante richiesta autorizzazione:"+response.error.message);

                      } else { // Token was created!

                        $ionicLoading.show({
                            title: '',
                            template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                        });
                        // Get the token ID:
                        var token = response.id;
                        // $cordovaDialogs.alert("Stripe authyoken ok:"+token);



                        //Prepara dati da inviare a finalizzazione
                        var payData =  {
                            stripe_token: token,
                            buyer: ( AuthServices.getLoggedUser()!=undefined)
                              ? AuthServices.getLoggedUser().credential.email
                              : '',
                            gateway: "stripe",
                            orders:[]
                        }

                        for (var i = 0; i < vm.orders.length; i++) {
                            var o = vm.orders[i];
                            vm.trnx_id = o.trnx_id ;

                            var newo = {
                                _id: o._id,
                                ticket_id: o.ticket._id,
                                quantity: o.quantity,
                                attendees:[]
                            };

                            try {

                              for (var j = 0; j < o.attendees.length; j++) {
                                  var a =  o.attendees[j];
                                  var newa = {
                                    name:a.name,
                                    surname:a.surname,
                                    email:a.email
                                  }
                                  //survey
                                  if(o.survey && o.survey.entries && o.survey.entries.length>0){
                                    newa.survey = {};
                                    for (var x = 0; x < o.survey.entries.length; x++) {
                                      var s = o.survey.entries[x];
                                      if(s.type=='text' || s.type=='textarea'){
                                        newa.survey['field_'+x] = a.survey['field_'+x];
                                      }else{
                                          if(s.type=='radio' || s.type=='select' || s.type=='checkbox'){
                                            newa.survey['field_'+x] = [];
                                            for (var property in a.survey['field_'+x]) {

                                                if (a.survey['field_'+x].hasOwnProperty(property)) {
                                                    if(a.survey['field_'+x][property]!=''){
                                                      newa.survey['field_'+x].push(property);
                                                    }
                                                }
                                            }

                                          }

                                      }
                                    }
                                  }
                                  newo.attendees.push(newa);
                              }



                            } catch (e) {
                              $ionicLoading.hide();
                              $cordovaDialogs.alert($interpolate("{{ 'order_error'  | translate }}")($scope)+e, 'Metooo', "OK");
                              return;
                            }
                            payData.orders.push(newo);
                        }


                        var postData = {
                          id_event:vm.selectedEvent._id,
                          id_trnx:vm.trnx_id,
                          data:payData
                        }
                        EventsServices.postFinalizeOrders(postData)
                        .then(function(response){
                            $ionicLoading.hide();
                            if(response.state=='OK'){
                              $state.go('main.events.detail.buytickets.assign.end', {id:vm.selectedEvent._id, orders:vm.orders, ordersResponse:postData});

                            }else{
                              $cordovaDialogs.alert($interpolate("{{ 'order_error'  | translate }}")($scope), 'Metooo', "OK");
                              // $cordovaDialogs.alert('Problemi durante finalizzazione ordine:'+response.msg);
                            }

                        },function(err){
                            $ionicLoading.hide();
                            $cordovaDialogs.alert($interpolate("{{ 'order_error'  | translate }}")($scope)+err, 'Metooo', "OK");
                        });
                    }
                });
              }

              function startCountDown(){
                vm.countDownTimer = $timeout(function () {
                  if(vm.totals.time.s>0){
                    vm.totals.time.s--;
                  }else{
                    vm.totals.time.s = 59;
                    if(vm.totals.time.m>0){
                      vm.totals.time.m--;
                    }else{
                      $timeout.cancel(vm.countDownTimer);
                      vm.countDownTimer = null;
                      $cordovaDialogs.alert($interpolate("{{ 'time_expired'  | translate }}")($scope), 'Metooo', "OK");
                      $state.go('main.events.detail.buytickets', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
                      return;
                    }
                  }
                  vm.startCountDown();
                }, 1000);
              }



              $scope.$on("$ionicView.beforeLeave", function(event, data){
                if(  vm.countDownTimer != null){
                    $timeout.cancel(vm.countDownTimer);
                }
              });
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.orders = $stateParams.orders ? $stateParams.orders : {};
                vm.totals = $stateParams.totals ? $stateParams.totals : {};

                vm.startCountDown();

              });

          }
      ])

      .controller('EventBuyTicketsPayFreeController', ['$state', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log', '$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $interpolate) {
              //$log.log(('EventBuyTicketsPayFreeController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orders: [],
                totals: {},
                currentTicketIndex: 0,
                currentTicket: {},
                currentState: 0,
                countDownTimer : null,
                startCountDown: startCountDown,
                trnx_id:'',
                doPayFree:doPayFree
              });




              function doPayFree(){
                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });

                  //Prepara dati da inviare a finalizzazione
                  var payData =  {
                      buyer: ( AuthServices.getLoggedUser()!=undefined)
                        ? AuthServices.getLoggedUser().credential.email
                        : '',
                      gateway: "free",
                      orders:[]
                  }

                  for (var i = 0; i < vm.orders.length; i++) {
                      var o = vm.orders[i];
                      vm.trnx_id = o.trnx_id ;

                      var newo = {
                          _id: o._id,
                          ticket_id: o.ticket._id,
                          quantity: o.quantity,
                          attendees:[]
                      };

                      try {

                        for (var j = 0; j < o.attendees.length; j++) {
                            var a =  o.attendees[j];
                            var newa = {
                              name:a.name,
                              surname:a.surname,
                              email:a.email
                            }
                            //survey
                            if(o.survey && o.survey.entries && o.survey.entries.length>0){
                              newa.survey = {};
                              for (var x = 0; x < o.survey.entries.length; x++) {
                                var s = o.survey.entries[x];
                                if(s.type=='text' || s.type=='textarea'){
                                  newa.survey['field_'+x] = a.survey['field_'+x];
                                }else{
                                    if(s.type=='radio' || s.type=='select' || s.type=='checkbox'){
                                      newa.survey['field_'+x] = [];
                                      for (var property in a.survey['field_'+x]) {

                                          if (a.survey['field_'+x].hasOwnProperty(property)) {
                                              if(a.survey['field_'+x][property]!=''){
                                                newa.survey['field_'+x].push(property);
                                              }
                                          }
                                      }

                                    }

                                }
                              }
                            }
                            newo.attendees.push(newa);
                        }



                      } catch (e) {
                        $ionicLoading.hide();
                        $cordovaDialogs.alert($interpolate("{{ 'order_error'  | translate }}")($scope)+":"+e, 'Metooo', "OK");
                        // $cordovaDialogs.alert('Problemi durante preparazione finalizzazione:'+e);
                        return;
                      }
                      payData.orders.push(newo);
                  }


                  var postData = {
                    id_event:vm.selectedEvent._id,
                    id_trnx:vm.trnx_id,
                    data:payData
                  }
                  EventsServices.postFinalizeOrders(postData)
                  .then(function(response){
                      $ionicLoading.hide();
                      if(response.state=='OK'){
                        $state.go('main.events.detail.buytickets.assign.end', {id:vm.selectedEvent._id, orders:vm.orders, ordersResponse:postData});

                      }else{
                        // $cordovaDialogs.alert('Problemi durante finalizzazione ordine:'+response.msg);
                        $cordovaDialogs.alert(  $interpolate("{{ 'order_error'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );
                      }

                  },function(err){
                      $ionicLoading.hide();
                      $cordovaDialogs.alert(  $interpolate("{{ 'order_error'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );
                      // alert("err_____________________________"+err);
                  });

              }

              function startCountDown(){
                vm.countDownTimer = $timeout(function () {
                  if(vm.totals.time.s>0){
                    vm.totals.time.s--;
                  }else{
                    vm.totals.time.s = 59;
                    if(vm.totals.time.m>0){
                      vm.totals.time.m--;
                    }else{
                      $timeout.cancel(vm.countDownTimer);
                      vm.countDownTimer = null;
                      // $cordovaDialogs.alert('Tempo a disposizione scaduto');
                      $cordovaDialogs.alert(  $interpolate("{{ 'time_expired'  | translate }}")($scope), 'Metooo', 'OK' );
                      $state.go('main.events.detail.buytickets', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
                      return;
                    }
                  }
                  vm.startCountDown();
                }, 1000);
              }



              $scope.$on("$ionicView.beforeLeave", function(event, data){
                if(  vm.countDownTimer != null){
                    $timeout.cancel(vm.countDownTimer);
                }
              });
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.orders = $stateParams.orders ? $stateParams.orders : {};
                vm.totals = $stateParams.totals ? $stateParams.totals : {};

                vm.startCountDown();

              });

          }
      ])

      .controller('EventBuyTicketsPayPaypalController', ['$state', 'ENV', '$http', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log', '$cordovaInAppBrowser', '$interpolate',
          function ($state, ENV, $http, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $cordovaInAppBrowser, $interpolate) {
              //$log.log(('EventBuyTicketsPayPaypalController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orders: [],
                totals: {},
                currentTicketIndex: 0,
                currentTicket: {},
                currentState: 0,
                countDownTimer : null,
                startCountDown: startCountDown,
                doPayWithPaypal: doPayWithPaypal,
                payWithPayPal: false,
                trnx_id:'',
                trnx_code:'',
                // getPayKey: getPayKey,
                pay_url:'',
                paykey:'',
                cancel_url:'',
                return_url:'',
                doPay:doPay,
                checkPayPalURL:checkPayPalURL,
                lastPostData:{},
                paymentResult:''
              });



              function doPay(postData) {
                // return;
                  vm.lastPostData = postData;
                  var options = {
                    location: 'yes',
                     clearcache: 'yes',
                     clearsessioncache:'yes',
                    toolbar: 'yes'
                  };

                  vm.pay_url = ENV.paypal_url+vm.paykey;//+"&autoredirectondone=";
                  $cordovaInAppBrowser.open(
                      vm.pay_url
                      +"&returnUrl="+encodeURIComponent(vm.return_url)
                      +"&cancelUrl="+encodeURIComponent(vm.cancel_url),
                      '_blank', options)
                  .then(function(event) {
                    // success
                    //$log.log(("SUCCESS: " + JSON.stringify(event));
                  })
                  .catch(function(event) {
                    // error
                      //$log.log(("ERROR: " + JSON.stringify(event));
                  });

              }

              function checkPayPalURL(url, evname){
                  if(url.indexOf(vm.return_url)!=-1){
                      try{$cordovaInAppBrowser.close();}catch(e){}
                      vm.paykey = '';
                      $state.go('main.events.detail.buytickets.assign.end', {id:vm.selectedEvent._id, orders:vm.orders, ordersResponse:vm.lastPostData });

                  }else  if(url.indexOf(vm.cancel_url)!=-1){
                      try{$cordovaInAppBrowser.close();}catch(e){}
                    //  $cordovaDialogs.alert('Pagamento non effettuato!');
                      vm.paymentResult = 'KO';
                      // vm.paykey = ''
                  }else if(evname=='exit' || url.toLowerCase().indexOf("closewindow")!=-1 ){
                      try{$cordovaInAppBrowser.close();}catch(e){}
                      $ionicLoading.show({
                          title: '',
                          template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                      });
                      EventsServices.checkPayPalPayment(vm.paykey).then(
                        function (response) {
                          $ionicLoading.hide();
                          if(response.data){
                            vm.paykey = '';
                            $state.go('main.events.detail.buytickets.assign.end', {id:vm.selectedEvent._id, orders:vm.orders, ordersResponse:vm.lastPostData });
                          }else{
                              vm.paymentResult = 'KO';
                          }
                        }, function(err){
                            $ionicLoading.hide();
                        }
                      );
                  }

              }

              $rootScope.$on('$cordovaInAppBrowser:loadstart', function(e, event){
               vm.checkPayPalURL(event.url,'loadstart');
              });

              $rootScope.$on('$cordovaInAppBrowser:loadstop', function(e, event){
                vm.checkPayPalURL(event.url,'loadstop');
              });

              $rootScope.$on('$cordovaInAppBrowser:exit', function(e, event){
                  vm.checkPayPalURL('','exit');
              });

              $rootScope.$on('$cordovaInAppBrowser:loaderror', function(e, event){
                //$log.log(("$cordovaInAppBrowser:loaderror " + JSON.stringify(event));
              });

              function doPayWithPaypal(){
                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });

                  //Prepara dati da inviare a finalizzazione
                  var payData =  {
                      buyer: ( AuthServices.getLoggedUser()!=undefined) ? AuthServices.getLoggedUser().credential.email : '',
                      gateway: "paypal",
                      orders:[]
                  }

                  for (var i = 0; i < vm.orders.length; i++) {
                      var o = vm.orders[i];
                      vm.trnx_id = o.trnx_id ;
                      vm.trnx_code = o.trnx_code ;

                      var newo = {
                          _id: o._id,
                          ticket_id: o.ticket._id,
                          quantity: o.quantity,
                          attendees:[]
                      };

                      try {

                        for (var j = 0; j < o.attendees.length; j++) {
                            var a =  o.attendees[j];
                            var newa = {
                              name:a.name,
                              surname:a.surname,
                              email:a.email
                            }
                            //survey
                            if(o.survey && o.survey.entries && o.survey.entries.length>0){
                              newa.survey = {};
                              for (var x = 0; x < o.survey.entries.length; x++) {
                                var s = o.survey.entries[x];
                                if(s.type=='text' || s.type=='textarea'){
                                  newa.survey['field_'+x] = a.survey['field_'+x];
                                }else{
                                    if(s.type=='radio' || s.type=='select' || s.type=='checkbox'){
                                        newa.survey['field_'+x] = [];
                                        for (var property in a.survey['field_'+x]) {
                                            if (a.survey['field_'+x].hasOwnProperty(property)) {
                                                if(a.survey['field_'+x][property]!=''){
                                                    newa.survey['field_'+x].push(property);
                                                }
                                            }
                                        }
                                    }
                                }
                              }
                            }
                            newo.attendees.push(newa);
                        }



                      } catch (e) {
                        $ionicLoading.hide();
                        $cordovaDialogs.alert(  $interpolate("{{ 'order_error'  | translate }}")($scope)+":"+e, 'Metooo', 'OK' );

                        return;
                      }
                      payData.orders.push(newo);
                  }


                  var postData = {
                    id_event:vm.selectedEvent._id,
                    id_trnx:vm.trnx_id,
                    data:payData
                  }
                  if(vm.paykey != ''){
                    $ionicLoading.hide();
                      vm.doPay(postData);
                      return;
                  }

                  EventsServices.postFinalizeOrders(postData)
                  .then(function(response){
                      $ionicLoading.hide();
                      if(response.state=='OK'){

                          vm.cancel_url = ("https://www.metooo.io/e/"+vm.selectedEvent.url);
                          vm.return_url = ("https://www.metooo.io/order/complete/trnx_id/"+vm.trnx_id);

                          vm.paykey = response.data.gateway_response.pay_key;
                            vm.doPay(postData);
                      }else{
                        $cordovaDialogs.alert(  $interpolate("{{ 'order_pay_error'  | translate }}")($scope)+":"+response.msg, 'Metooo', 'OK' );
                      }

                  },function(err){
                      $ionicLoading.hide();
                      // $cordovaDialogs.alert("Problemi di collegamento durante pagamento ordine:"+err);
                      $cordovaDialogs.alert(  $interpolate("{{ 'order_pay_error'  | translate }}")($scope)+":"+err, 'Metooo', 'OK' );
                  });

              }

              function startCountDown(){
                vm.countDownTimer = $timeout(function () {
                  if(vm.totals.time.s>0){
                    vm.totals.time.s--;
                  }else{
                    vm.totals.time.s = 59;
                    if(vm.totals.time.m>0){
                      vm.totals.time.m--;
                    }else{
                      $timeout.cancel(vm.countDownTimer);
                      vm.countDownTimer = null;
                      $cordovaDialogs.alert('Tempo a disposizione scaduto');
                      try{$cordovaInAppBrowser.close();}catch(e){}
                      $state.go('main.events.detail.buytickets', {id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent});
                      return;
                    }
                  }
                  vm.startCountDown();
                }, 1000);
              }



              $scope.$on("$ionicView.beforeLeave", function(event, data){
                if(  vm.countDownTimer != null){
                    $timeout.cancel(vm.countDownTimer);
                }
              });
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.orders = $stateParams.orders ? $stateParams.orders : {};
                vm.totals = $stateParams.totals ? $stateParams.totals : {};

                vm.startCountDown();
                // vm.doPayWithPaypal();

              });

          }
      ])

      .controller('EventBuyTicketsPayEndController', ['$state', '$stateParams',  'AuthServices',  'EventsServices', '$ionicLoading', '$scope',  '$rootScope', '$cordovaSocialSharing', '$ionicModal','$cordovaDialogs', '$timeout', '$log' , '$ionicHistory', '$interpolate',
          function ($state, $stateParams, AuthServices, EventsServices, $ionicLoading,$scope, $rootScope, $cordovaSocialSharing, $ionicModal ,$cordovaDialogs, $timeout, $log, $ionicHistory, $interpolate) {
              //$log.log(('EventBuyTicketsPayEndController');

              var vm = angular.extend(this, {
                selectedEvent: {},
                orderResponse: {},
                orders: {},
                gotoEvent: gotoEvent,
                gotoSummary: gotoSummary
              });


              function gotoEvent(){
                $ionicLoading.show({
                    title: '',
                    template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                });
                $timeout(function () {
                  $ionicHistory.clearHistory();
                  $ionicLoading.hide();
                  $rootScope.backUISRef = {state:'main.events',params:{}};

                  $state.go('main.events.detail',{id:vm.selectedEvent._id, backUISRef:$rootScope.backUISRef});
                }, 100);

              }

              function gotoSummary(){
                  $state.go('main.events.detail.buytickets.assign.end.summary',{id:vm.selectedEvent._id, selectedEvent:vm.selectedEvent, orders:vm.orders});

              }

              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.ordersResponse = $stateParams.ordersResponse ? $stateParams.ordersResponse : {};
                vm.orders = $stateParams.orders ? $stateParams.orders: {};
                $ionicHistory.clearHistory();

              });

          }
      ])

      .controller('EventBuyTicketsEndSummaryController', ['$state', '$stateParams',  'AuthServices', 'uiGmapIsReady', '$cordovaCalendar', 'EventsServices', '$ionicLoading', '$ionicHistory', '$ionicActionSheet', '$compile', '$scope', '$ionicPopover', '$rootScope', '$cordovaBarcodeScanner', '$cordovaSocialSharing', '$ionicModal','uiGmapGoogleMapApi','$cordovaDialogs', '$timeout', '$log','ENV','$base64', '$interpolate',
          function ($state, $stateParams, AuthServices, uiGmapIsReady, $cordovaCalendar, EventsServices, $ionicLoading, $ionicHistory, $ionicActionSheet, $compile, $scope, $ionicPopover, $rootScope, $cordovaBarcodeScanner, $cordovaSocialSharing, $ionicModal ,uiGmapGoogleMapApi,$cordovaDialogs, $timeout, $log, ENV, $base64, $interpolate) {
              //$log.log(('EventBuyTicketsEndSummaryController');

              var vm = angular.extend(this, {
                selectedEvent:{},
                orders:[],

              });
              // $scope.qrcode = '000';
              // $scope.qrcode = '4aaassAA4444'.toUpperCase();
              $scope.$on("$ionicView.afterEnter", function(event, data){
                if(AuthServices.getLoggedUser()==undefined){
                  $state.go('main.events');
                  return;
                }

                vm.selectedEvent = $stateParams.selectedEvent ? $stateParams.selectedEvent : {};
                if('{}'==angular.toJson(vm.selectedEvent)){
                  $state.go('main.events', true);
                  return;
                }

                vm.orders = $stateParams.orders ? $stateParams.orders : {};

              });
          }
      ])



      .controller('EventsProfileController', ['$log', '$state', '$stateParams', '$cordovaDialogs','AuthServices', 'EventsServices', '$ionicLoading', '$scope',  '$rootScope',  '$ionicModal','$cordovaDatePicker','$timeout','$filter','$ionicPlatform','uiGmapGoogleMapApi', '$interpolate',
          function ($log, $state, $stateParams, $cordovaDialogs, AuthServices, EventsServices, $ionicLoading, $scope,  $rootScope, $ionicModal,$cordovaDatePicker,$timeout , $filter, $ionicPlatform,uiGmapGoogleMapApi, $interpolate) {
              //$log.info('EventsProfileController');



              var vm = angular.extend(this, {
                userProfile: $stateParams.userProfile ? $stateParams.userProfile : {},
                flyers:[],
                filter:{id:'',page:1, count:12},
                isLoading:false,
                dataLoadeds:false,
                loadEvents:loadEvents,
                loadMoreEvents:loadMoreEvents,
                existsMoreEvents:true,
                isPrivate:false
              });

              $scope.$on("$ionicView.beforeEnter", function(event, data){
                //$log.info('EventsProfileController:afterEnter');

                $timeout(function () {
                  vm.userProfile = $stateParams.userProfile ? $stateParams.userProfile : {};
                  vm.filter.id = vm.userProfile._id;
                  vm.isLoading = false;
                  vm.dataLoadeds = false;
                  vm.loadEvents(vm.filter);
                }, 50);


              });

              function loadMoreEvents(){
                vm.filter.page++;
                  vm.loadEvents(vm.filter);
              }

              function loadEvents(filt){
                try {
                  if(vm.isLoading) return;

                  $ionicLoading.show({
                      title: '',
                      template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                  });

                  vm.isLoading = true;
                  EventsServices.getUserEvents(filt).
                      then(function (response) {

                          $ionicLoading.hide();
                          vm.isLoading = false;

                          $scope.$broadcast('scroll.infiniteScrollComplete');

                          if (response.state === 'OK') {

                            try {
                              vm.existsMoreEvents = response.flyers.length>0 && response.flyers.length>=filt.count;
                            } catch (e) {
                              vm.existsMoreEvents = false;
                              return;
                            }

                              var flyers = response.flyers ;

                              var a='';
                              var d = null;
                              for (var i = 0; i < flyers.length; i++) {
                                  if(d!=flyers[i].start_date.substr(0,10)){
                                    flyers[i].hasDivider=true;
                                    d = flyers[i].start_date.substr(0,10);
                                  }
                                  // a = encodeURIComponent(vm.flyers[i].style.background_image);
                                  // vm.flyers[i].style.background_image = "https://api.metooo.io/img/360/195/" + a;
                                   a = encodeURIComponent(flyers[i].style.background_image);
                                   flyers[i].style.background_image = "" +a;

                                   flyers[i].coords ={
                                     latitude:flyers[i].location.lat,
                                     longitude:flyers[i].location.lng
                                   }

                               }
                               vm.flyers = filt.page==1 ? flyers : vm.flyers.concat(flyers);;
                          }
                          else{
                              vm.existsMoreEvents = false;
                              $cordovaDialogs.alert(  $interpolate("{{ 'event_list_server_error'  | translate }}")($scope), 'Metooo', 'OK' );

                          }
                          vm.dataLoadeds = true;
                      });
                } catch (e) {
                  vm.existsMoreEvents = false;
                  // alert(e);
                }

              }

          }

      ])


            .controller('EventsContactController', ['$log', '$state', '$stateParams', '$cordovaDialogs','AuthServices', 'EventsServices', '$ionicLoading', '$scope',  '$rootScope','$ionicHistory','$filter', '$interpolate',
                function ($log, $state, $stateParams, $cordovaDialogs, AuthServices, EventsServices, $ionicLoading, $scope,  $rootScope, $ionicHistory , $filter,  $interpolate) {
                    //$log.info('EventsProfileController');



                    var vm = angular.extend(this, {
                      user: AuthServices.getLoggedUser() ?  AuthServices.getLoggedUser()  : false,
                      userProfile: $stateParams.userProfile ? $stateParams.userProfile : {},
                      msg: {
                          user:'',
                          flyer: '',
                          name: '',
                          email: '',
                          body: ''
                      },
                      doSendMsg: doSendMsg,
                      selectedEvent: $stateParams.selectedEvent ?  $stateParams.selectedEvent  : false
                    });

                    $scope.$on("$ionicView.beforeEnter", function(event, data){
                    //  //$log.info('EventsContactController:afterEnter');


                      vm.user = AuthServices.getLoggedUser() ?  AuthServices.getLoggedUser()  : false;
                      vm.userProfile = $stateParams.userProfile ? $stateParams.userProfile : {};
                      vm.selectedEvent = $stateParams.selectedEvent ?  $stateParams.selectedEvent  : false;

                      vm.msg.body = '';

                      if(vm.user!==false){
                        vm.msg.user = vm.user._id;
                        vm.msg.email = vm.user.credential.email;
                        var n = vm.user.anagraphics.name + ' '+  vm.user.anagraphics.surname;
                        if(n.trim().length>0){
                            vm.msg.name = n;
                        }

                      }
                      if(vm.selectedEvent!==false){
                        vm.msg.flyer= vm.selectedEvent._id;

                      }
                    });


                    function doSendMsg(){
                        var isValid = vm.msg.name!='' && vm.msg.email!='' && vm.msg.msg!='';
                        if(!isValid){
                          $cordovaDialogs.alert(  $interpolate("{{ 'data_insert_error'  | translate }}")($scope), 'Metooo', 'OK' );

                            return;
                        }

                        $ionicLoading.show({
                            title: '',
                            template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
                        });
                        EventsServices.sendMessage(vm.userProfile._id ,vm.msg).then(
                          function(response){
                            $ionicLoading.hide();
                            if(response.state=='OK'){
                              $cordovaDialogs.alert(  $interpolate("{{ 'loading_email_sent'  | translate }}")($scope), 'Metooo', 'OK' );
                              $ionicHistory.goBack();
                            }else  if(response.state=='KOT'){
                                $cordovaDialogs.alert(  $interpolate("{{ 'msg_send_error_elepsedtime'  | translate }}")($scope), 'Metooo', 'OK' );
                                $ionicHistory.goBack();
                            } else {
                                $cordovaDialogs.alert(  $interpolate("{{ 'msg_send_error'  | translate }}")($scope), 'Metooo', 'OK' );
                            }

                          },
                          function(err){
                            $ionicLoading.hide();
                            $cordovaDialogs.alert(  $interpolate("{{ 'msg_send_error'  | translate }}")($scope)+err, 'Metooo', 'OK' );

                          }
                        );
                    }
                }


            ])

})();
