
(function () {
    'use strict';

    angular.module('intro.module', [])

    .controller('IntroController',
      ['$scope', '$rootScope','$log','$translate', '$state', '$timeout', '$document',
        function($scope, $rootScope, $log, $translate, $state, $timeout, $document) {
            $log.info('IntroController');

            $scope.data = {hideFloats:false};
            $scope.data.strings = [];
            $scope.data.pages = [
              {bg:'intro1.png'},
              {bg:'intro2.png'},
              {bg:'intro3.png'},
              {bg:'intro4.png'},
            ];
            $scope.data.currentPage = 0;


            $scope.dontSwipe = function (e){
            }
            var setupSlider = function() {
              //some options to pass to our slider
              $scope.data.sliderOptions = {
                initialSlide: 0,
                direction: 'horizontal', //or vertical
                speed: 300, //0.3s transition,
                // pagination:'white'
              };

              //create delegate reference to link with slider
              $scope.data.sliderDelegate = null;

              //watch our sliderDelegate reference, and use it when it becomes available
              $scope.$watch('data.sliderDelegate', function(newVal, oldVal) {
                if (newVal != null) {
                  $scope.data.sliderDelegate.on('onSlideNextStart', function() {
                    $timeout(function () {
                      $scope.data.currentPage = $scope.data.sliderDelegate.activeIndex;
                      $scope.data.hideFloats = ($scope.data.currentPage>=4);
                      var elem = $document[0].body.querySelector('.swiper-pagination');
                      elem.style.display = $scope.data.hideFloats ? 'none' : 'block';
                    }, 10);

                  //  $scope.$apply();

                  });

                  $scope.data.sliderDelegate.on('onSlidePrevStart', function() {
                    $timeout(function () {
                      $scope.data.currentPage = $scope.data.sliderDelegate.activeIndex;
                      $scope.data.hideFloats = ($scope.data.currentPage>=4);
                      var elem = $document[0].body.querySelector('.swiper-pagination');
                      elem.style.display = $scope.data.hideFloats ? 'none' : 'block';
                    }, 10);
                  //  $scope.$apply();

                  });
                }
              });
            };

            $rootScope.gotoSlide = function(s){
              $scope.data.sliderDelegate.slidePrev();
              // $scope.data.sliderDelegate.activeIndex = s;
            }


            // $scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
            //   $scope.data.currentPage = $scope.data.sliderDelegate.activeIndex;
            //   //use $scope.$apply() to refresh any content external to the slider
            //   $scope.$apply();
            // });

            $scope.loadStrings= function(){

              var keys = [];
              for (var i =1; i < 5; i++) {
                keys.push("messaggio_benvenuto_titolo_"+i);
                keys.push("messaggio_benvenuto_text_"+i);
              }
              keys.push("intro_btn_enter");
              keys.push("intro_btn_signup");
              keys.push("intro_btn_login");

              $rootScope.$on('$translateChangeSuccess', function () {
                $log.info('IntroController.translateChangeSuccess');
                $translate(keys).then(function (translations) {
                    $log.info('IntroController.translateChangeSuccess.loadeds');
                  for (var i =1; i < 5; i++) {
                    $scope.data.strings["messaggio_benvenuto_titolo_"+i] = translations["messaggio_benvenuto_titolo_"+i];
                    $scope.data.strings["messaggio_benvenuto_text_"+i] = translations["messaggio_benvenuto_text_"+i];
                  }
                  $scope.data.strings["intro_btn_enter"] = translations["intro_btn_enter"];
                  $scope.data.strings["intro_btn_signup"] = translations["intro_btn_signup"];
                  $scope.data.strings["intro_btn_login"] = translations["intro_btn_login"];
                });
              });

            };

            $scope.$on("$ionicView.loaded", function(event, data){
              $scope.loadStrings()
            });


            setupSlider();
        }
      ]
    )

})();

;
