
(function () {
    'use strict';

    angular.module('myevents.module', [])

    .controller('MyEventsController',
              ['$scope', '$rootScope','$log',  'AuthServices','$state','$cordovaDialogs','$ionicLoading','MyEventsServices', '$ionicScrollDelegate', '$cordovaInAppBrowser',

        function($scope, $rootScope, $log,  AuthServices, $state, $cordovaDialogs, $ionicLoading, MyEventsServices, $ionicScrollDelegate, $cordovaInAppBrowser){
            //$log.info('MyEventsController');

            var vm = angular.extend(this, {
              user: AuthServices.getLoggedUser(),
              loadMoreEvents:loadMoreEvents,
              loadEvents:loadEvents,
              filter:{ page: 1, count: 15 },
              isLoading:false,
              isFirstLoadDone:false,
              flyers:[],
              createNewEvent:createNewEvent
            });

            function createNewEvent(){
              $cordovaInAppBrowser.open("https://www.metooo.io", '_system', {})
              .then(function(event) {
              })
              .catch(function(event) {
                //  console.log("ERROR: " + JSON.stringify(event));
              });
            }

            function loadMoreEvents(f){
            if(vm.isLoading) return;
              vm.filter.page = vm.filter.page + 1 ;
              vm.loadEvents( vm.filter);
            }

            function loadEvents(f){

              if(vm.isLoading) return;
              vm.isLoading = true;
              $ionicLoading.show({
                  title: '',
                  template: '<ion-spinner icon="lines" class="spinner-positive"></ion-spinner>'
              });

              MyEventsServices.getEvents(1, f).
                  then(function (response) {
                      $ionicLoading.hide();

                      vm.isFirstLoadDone = true;
                      $scope.$broadcast('scroll.infiniteScrollComplete');
                      if (response.state === 'OK') {

                          vm.noMoreEvents = response.flyers.length==0 || response.flyers.length<f.count;

                          // vm.flyers = [];
                          var flyers = response.flyers ;

                          var a = '';
                          var d = null;
                          for (var i = 0; i < flyers.length; i++) {
                              if(d!=flyers[i].start_date.substr(0,10)){
                                flyers[i].hasDivider=true;
                                d = flyers[i].start_date.substr(0,10);
                              }
                              a = encodeURIComponent(flyers[i].style.background_image);
                              flyers[i].style.background_image = "" +a;

                              // flyers[i].coords ={
                              //    latitude:flyers[i].location.lat,
                              //    longitude:flyers[i].location.lng
                              // }
                           }
                           if(f.page==1){
                             vm.flyers = [];
                             vm.flyers = flyers;
                             $ionicScrollDelegate.$getByHandle('my-events-scroll').scrollTop();
                           }else {
                              vm.flyers = vm.flyers.concat(flyers);;
                           }
                      }
                      else{
                        vm.noMoreEvents = true;
                        //  alert("Geocoder failed due to: " + status);
                        $cordovaDialogs.alert($interpolate("{{ 'event_list_error'  | translate }}")($scope), 'Metooo', "OK");
                        // $cordovaDialogs.alert('Problemi durante caricamento degli eventi. Verificare connessione', 'Metooo', 'OK' )

                      }

                      vm.isLoading = false;
                  });
            }

            $scope.$on('mt-user-logged', function(event,data){
              vm.user = AuthServices.getLoggedUser();
            })

            $scope.$on("$ionicView.loaded", function(event, data){
              vm.user = AuthServices.getLoggedUser();

            });

            $scope.$on("$ionicView.afterEnter", function(event, data){
              if(AuthServices.getLoggedUser()==undefined ){
                $state.go('main.events');
                return;
              }else{
                vm.filter ={ page: 1, count: 15 };
                vm.loadEvents(vm.filter);
              }

            });

        }
      ]
    )
    .service('MyEventsServices', ['$http', '$timeout','ENV','$log','$q', 'AuthServices','$interpolate',
        function ( $http, $timeout, ENV, $log, $q ,AuthServices, $interpolate) {

            return {

              getEvents: function (page, filter) {
                  var headers = {};
                  try {
                    if( AuthServices.getLoggedUser().access_token.token){
                      headers= {
                          "Authorization": "Bearer " + AuthServices.getLoggedUser().access_token.token
                      }
                    }
                  } catch (e) { }

                  var req =  {
                     method: 'GET' ,
                     url: ENV.apiUrl+'flyers?filter=not_deleted',
                     headers: headers,
                     data: filter
                  }

                  return $http(req).
                    then(function (response) {

                        return {
                            state: 'OK',
                            flyers: response.data.flyers,
                            pagination: response.data.flyers_pagination
                        };

                    }, function (response) {

                        var responseMsg = response.data && response.data.msg ?
                            response.data.msg : $cordovaDialogs.alert($interpolate("{{ 'event_list_server_error'  | translate }}")($scope), 'Metooo', "OK");
                            // "Errore remoto. Non riesco a comunicare con il server!";

                        return {
                            state: 'KO',
                            msg: responseMsg
                        };
                    });
                },

            };

        }

    ]);

})();

;
