
(function () {
    'use strict';

    angular.module('profile.module', [])

    .controller('ProfileController',
      ['$scope', '$rootScope','$log', '$translate', 'AuthServices','$state','$cordovaDialogs','$ionicLoading',
        function($scope, $rootScope, $log, $translate, AuthServices, $state, $cordovaDialogs, $ionicLoading) {
            $log.info('ProfileController');

            var vm = angular.extend(this, {
              user: AuthServices.getLoggedUser(),
              logout:function(){

                $cordovaDialogs.confirm('Conferma uscita?', 'Metooo', ['Esci','Annulla'])
                .then(function(buttonIndex) {
                  // no button = 0, 'OK' = 1, 'Cancel' = 2
                  var btnIndex = buttonIndex;
                  if(btnIndex==1){
                    $ionicLoading.show({
                        title: 'Metooo',
                        template: '{{"profile_logout" | translate}}'
                    });
                    $log.info('logout');
                    AuthServices.logout().then(
                      function (resp) {
                        $ionicLoading.hide();
                        $state.go('main.events');
                      },function (err) {
                        $log.error(err);
                      }
                    );
                  }
                });


              }
            });


            $rootScope.$on('mt-user-logged', function(event,data){
              vm.user = AuthServices.getLoggedUser();
            })


            $scope.$on("$ionicView.loaded", function(event, data){
              vm.user = AuthServices.getLoggedUser();
            });



        }
      ]
    )

})();

;
