(function () {
    'use strict';

    angular.module('app.routes', [])
    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
      // console.log('conf 2');

        // $httpProvider.defaults.headers.common['Access-Control-Allow-Headers'] = '*';
        $stateProvider
            .state('intro', {
                url: '/intro',
                views: {
                  'index': {
                    templateUrl: 'app/intro/html/intro.html',
                    controller: 'IntroController'
                  }
                }
            })

            .state('privacy', {
                url: "/privacy",
                views: {
                  'index': {
                    templateUrl: "app/auth/html/signup-privacy-tab.html",
                  //  controller: 'PrivacyController as vm'
                  }
                }

            })
            .state('main', {
                url: '/main',
                views: {
                  'index': {
                    templateUrl: 'app/main/html/main.html',
                    controller: function ($scope, $rootScope, $ionicModal, $cordovaSocialSharing) {
                        $scope.sideMenu = null;
                        $ionicModal.fromTemplateUrl('app/main/html/sidemenu.html', {
                          scope: $scope,
                          animation: 'slide-in-left-right'
                        }).then(function(modal){
                            $scope.sideMenu = modal;
                        });
                        $rootScope.openSideMenu = function(){
                          $scope.sideMenu.show();
                        }
                        $rootScope.hideSideMenu = function(){
                          $scope.sideMenu.hide();
                        }
                        $rootScope.openShareSys = function(message, subject, file, link){

                          var options = {
                            message: message, // not supported on some apps (Facebook, Instagram)
                            subject: subject, // fi. for email
                            files: [], // an array of filenames either locally or remotely
                            url: link,
                            //chooserTitle: 'Pick an app' // Android only, you can override the default share sheet title
                          }

                          var onSuccess = function(result) {
                          //  console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
                          //  console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
                          }

                          var onError = function(msg) {
                          //  console.log("Sharing failed with message: " + msg);
                          }

                          window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
                          // $cordovaSocialSharing
                          //   .share(message, subject, file, link) // Share via native share sheet
                          //   .then(
                          //     function(result) { },
                          //     function(err) { }
                          //   );
                        }
                        $rootScope.hideShareModal = function(){
                          $scope.shareModal.hide();
                        }


                    }
                  }
                },
                abstract: true,
            })

            .state('main.events', {
                url: '/events',
                views: {
                  'main@main': {
                    templateUrl: "app/events/events.html",
                     controller: 'EventsController as vm'
                  }
                }
            })
            .state('main.events.map', {
                url: '/map',
                params:{
                  flyers:[]
                },
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-map.html",
                     controller: 'EventsMapController as vm'

                  }
                }
            })

            .state('main.events.setplace', {
                url: '/setplace',

                views: {
                  'main@main': {
                    templateUrl: "app/events/events-search-place.html",
                      controller: 'EventsSearchPlaceController as vm'

                  }
                }
            })

            .state('main.events.detail', {
                url: '/:id',
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-detail.html",
                    controller: 'EventDetailController as vm'
                  },
                  params:{
                    backUISRef:{}
                  }
                }
            })

            .state('main.events.detail.buytickets', {
                url: '/buytickets',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets.html",
                    controller: 'EventBuyTicketsController as vm'
                  }
                },
                params:{
                  selectedEvent:{}
                }
            })
            .state('main.events.detail.buytickets.assign', {
                url: '/assign',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-assign.html",
                    controller: 'EventBuyTicketsAssignController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  orders:[]
                }
            })
            .state('main.events.detail.buytickets.assign.pay', {
                url: '/pay',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-pay.html",
                    controller: 'EventBuyTicketsPayController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  tickets:[],
                  totals:{}
                }
            })
            .state('main.events.detail.buytickets.assign.pay.stripe', {
                url: '/stripe',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-pay-stripe.html",
                    controller: 'EventBuyTicketsPayStripeController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  tickets:[],
                  totals:{}
                }
            })
            .state('main.events.detail.buytickets.assign.pay.free', {
                url: '/free',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-pay-free.html",
                    controller: 'EventBuyTicketsPayFreeController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  tickets:[],
                  totals:{}
                }
            })
            .state('main.events.detail.buytickets.assign.end', {
                url: '/end',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-end.html",
                    controller: 'EventBuyTicketsPayEndController as vm'
                  }
                },
                params:{
                  selectedEvent: {},
                  ordersResponse: {},
                  orders: [],
                }
            })
            .state('main.events.detail.buytickets.assign.end.summary', {
                url: '/summary',
                views: {
                  'main@main': {
                    templateUrl: "app/events/html/buy-tickets-end-summary.html",
                    controller: 'EventBuyTicketsEndSummaryController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  orders:[]
                }
            })
            .state('main.events.detail.buytickets.assign.pay.paypal', {
                url: '/paypal',
                views: {
                  'main@main': {
                    templateUrl: "app/events/buy-tickets-pay-paypal.html",
                    controller: 'EventBuyTicketsPayPaypalController as vm'
                  }
                },
                params:{
                  selectedEvent:{},
                  tickets:[],
                  totals:{}
                }
            })
            .state('main.events.detail.userprofile', {
                url: '/userprofile',
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-profile.html",
                    controller: 'EventsProfileController as vm'
                  }
                },
                params:{
                  userProfile:{}
                }
            })

            .state('main.events.detail.contact', {
                url: '/contact',
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-detail-contact.html",
                    controller: 'EventsContactController as vm'
                  }
                }
                ,
                params:{
                  userProfile:{}, selectedEvent:{},
                }
            })

            .state('main.events.search', {
                url: '/search',
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-search.html",
                    controller: 'EventsSearchController as vm'
                  }
                }
            })

            .state('main.tickets', {
                url: "/tickets",
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-tickets.html",
                    controller: 'TicketsController as vm'
                  }
                }
            })
            .state('main.tickets.list', {
                url: "/list",
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-tickets-list.html",
                    controller: 'TicketsListController as vm'
                  }
                },
                params:{selectedTicket:{}}
            })
            .state('main.tickets.list.detail', {
                url: "/:id",
                views: {
                  'main@main': {
                    templateUrl: "app/events/events-tickets-detail.html",
                    controller: 'TicketsDetailController as vm'
                  }
                },
                params:{selectedTicket:{}, selectedOrder:{}, selectedAttendees:{}}
            })
            .state('main.myevents', {
                url: "/myevents",
                views: {
                  'main@main': {
                    templateUrl: "app/my-events/html/my-events.html",
                    controller: 'MyEventsController as vm'
                  }
                }
            })
            .state('main.profile', {
                url: "/profile",
                views: {
                  'main@main': {
                    templateUrl: "app/profile/html/profile.html",
                    controller: 'ProfileController as vm'
                  }
                }
            })
            .state('main.about', {
                url: "/about",
                views: {
                  'main@main': {
                    templateUrl: "app/about/html/about.html",
                    controller: 'AboutController'
                  }
                }
            })

            ;
            $urlRouterProvider.otherwise('/intro');
        // $urlRouterProvider.otherwise('/authenticate/login');
    });

})();
